SystemOrganization addCategory: #TinyTower!

DocumentLogic subclass: #TinyTowerGameDocLogic
	instanceVariableNames: 'game hasUnsavedChange'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!TinyTowerGameDocLogic methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/30/2014 00:11'!
game: aTinyTowerGame 
	game := aTinyTowerGame! !

!TinyTowerGameDocLogic methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/30/2014 00:11'!
hasSaveMedium
	^true! !

!TinyTowerGameDocLogic methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/30/2014 00:11'!
hasUnsavedChange
	^hasUnsavedChange setDefault: #hasUnsavedChangeDefault for: self withSetter: #hasUnsavedChange:
! !

!TinyTowerGameDocLogic methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/30/2014 00:11'!
hasUnsavedChange: aBoolean
	hasUnsavedChange := aBoolean! !

!TinyTowerGameDocLogic methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/30/2014 00:11'!
hasUnsavedChangeDefault
	^false! !

!TinyTowerGameDocLogic methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/30/2014 00:12'!
saveMediumIsObsolete
	^false! !

Morph subclass: #BitizenMorph
	instanceVariableNames: 'model dreamJobListModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!BitizenMorph commentStamp: '' prior: 0!
A BitizenController is xxxxxxxxx.

Instance Variables
	model:		<Object>

model
	- xxxxx
!

!BitizenMorph methodsFor: 'set index' stamp: 'HwaJong 3/17/2014 11:18'!
bitizenChanged

	self changed: #bitizenProperty! !

!BitizenMorph methodsFor: 'bitizen name' stamp: 'HwaJong 2/23/2014 22:42'!
bitizenName
	^model
		ifNil: [ '' ]
		ifNotNil: [ model bitName ]! !

!BitizenMorph methodsFor: 'bitizen name' stamp: 'HwaJong 3/17/2014 11:18'!
bitizenName: aString
	model bitName: aString.
	self changed: #bitizenName.
	self bitizenChanged! !

!BitizenMorph methodsFor: 'droplist' stamp: 'HwaJong 2/23/2014 22:42'!
creativeDropList
	^self dropListZeroToNine! !

!BitizenMorph methodsFor: 'get index' stamp: 'HwaJong 2/23/2014 22:42'!
creativeDropListIndex
	^self dropListIndexWithAbilityGetter: #creativeAbility! !

!BitizenMorph methodsFor: 'set index' stamp: 'HwaJong 3/8/2014 20:42'!
creativeDropListIndex: anInteger 
	self dropListIndex: anInteger abilitySetter: #creativeAbility:! !

!BitizenMorph methodsFor: 'dream job' stamp: 'HwaJong 2/25/2014 00:50'!
dreamJobDropList
	^self dreamJobListModel list collect: [ :each| each ifNil: [ 'nil' ] ifNotNil: [each jobName] ]! !

!BitizenMorph methodsFor: 'dream job' stamp: 'HwaJong 2/23/2014 23:36'!
dreamJobDropListIndex
	^self dreamJobListModel selectionIndex! !

!BitizenMorph methodsFor: 'dream job' stamp: 'HwaJong 3/17/2014 11:21'!
dreamJobDropListIndex: anInteger 
	self dreamJobListModel selectionIndex: anInteger.
	model dreamJob: self dreamJobListModel selection.
	self bitizenChanged.! !

!BitizenMorph methodsFor: 'dream job' stamp: 'HwaJong 2/23/2014 23:35'!
dreamJobListModel
	^dreamJobListModel setDefault: #dreamJobListModelDefault for: self withSetter: #dreamJobListModel:! !

!BitizenMorph methodsFor: 'dream job' stamp: 'HwaJong 2/23/2014 23:36'!
dreamJobListModel: aTGListModel 
	dreamJobListModel := aTGListModel! !

!BitizenMorph methodsFor: 'dream job' stamp: 'HwaJong 2/23/2014 23:36'!
dreamJobListModelDefault
	^TGListModel new! !

!BitizenMorph methodsFor: 'set index' stamp: 'HwaJong 3/17/2014 11:21'!
dropListIndex: anInteger abilitySetter: aSymbol
	model perform: aSymbol with: anInteger-1.
	self bitizenChanged.! !

!BitizenMorph methodsFor: 'get index' stamp: 'HwaJong 3/15/2014 16:00'!
dropListIndexWithAbilityGetter: aSymbol
	^(model isNil or: [(model perform: aSymbol) isNil])
		ifTrue: [0]
		ifFalse: [ (model perform: aSymbol)+1 ]! !

!BitizenMorph methodsFor: 'droplist' stamp: 'HwaJong 2/23/2014 22:42'!
dropListZeroToNine
	^(0 to: 9) asArray! !

!BitizenMorph methodsFor: 'droplist' stamp: 'HwaJong 2/23/2014 22:42'!
foodDropList
	^self dropListZeroToNine! !

!BitizenMorph methodsFor: 'get index' stamp: 'HwaJong 2/23/2014 22:42'!
foodDropListIndex
	^self dropListIndexWithAbilityGetter: #foodAbility! !

!BitizenMorph methodsFor: 'set index' stamp: 'HwaJong 2/23/2014 22:42'!
foodDropListIndex: anInteger 
	self dropListIndex: anInteger abilitySetter: #foodAbility:! !

!BitizenMorph methodsFor: 'initialization' stamp: 'HwaJong 3/21/2014 13:27'!
initialize
	|q|
	super initialize.
	self color: Color transparent.
	self beShrinkWrapping.
	self layoutPolicy: ProportionalLayout new.
	q := QuickPrototyping for: self.
	
	{ 
		{ q staticLabel: 'name'. q text: #bitizenName }.
		{ q staticLabel: 'dream job'. q dropList: #dreamJob }.
		{ q staticLabel: 'food'. q dropList: #food }.
		{ q staticLabel: 'service'. q dropList: #service }.
		{ q staticLabel: 'recreation'. q dropList: #recreation }.
		{ q staticLabel: 'retail'. q dropList: #retail }.
		{ q staticLabel: 'creative'. q dropList: #creative }.
	}
		keysAndValuesDo:  [:rowIndex :array| 
			self addMorph: (array first) fullFrame: (LayoutFrame fractions: (0@0 corner: 0@0) offsets: (0@(25*(rowIndex-1)) corner: 100@(25*rowIndex))).
			self addMorph: (array second) fullFrame: (LayoutFrame fractions: (0@0 corner: 0@0) offsets: (100@(25*(rowIndex-1)) corner: 250@(25*rowIndex)))].! !

!BitizenMorph methodsFor: 'accessing' stamp: 'HwaJong 2/23/2014 23:27'!
model
	^model! !

!BitizenMorph methodsFor: 'accessing' stamp: 'HwaJong 3/15/2014 15:57'!
model: aBitizen 
	model := aBitizen.
	self changed: #foodDropListIndex.
	self changed: #serviceDropListIndex.
	self changed: #recreationDropListIndex.
	self changed: #retailDropListIndex.
	self changed: #creativeDropListIndex.
	self changed: #bitizenName.
	
	self dreamJobListModel 
		list: ({nil},(model game jobs asSortedCollection: (UnarySortDescriptor ascendingBy: #jobName)));
		selection: model dreamJob.
	self changed: #dreamJobDropList.
	self changed: #dreamJobDropListIndex.! !

!BitizenMorph methodsFor: 'droplist' stamp: 'HwaJong 2/23/2014 22:42'!
recreationDropList
	^self dropListZeroToNine! !

!BitizenMorph methodsFor: 'get index' stamp: 'HwaJong 2/23/2014 22:42'!
recreationDropListIndex
	^self dropListIndexWithAbilityGetter: #recreationAbility! !

!BitizenMorph methodsFor: 'set index' stamp: 'HwaJong 2/23/2014 22:42'!
recreationDropListIndex: anInteger 
	self dropListIndex: anInteger abilitySetter: #recreationAbility:! !

!BitizenMorph methodsFor: 'droplist' stamp: 'HwaJong 2/23/2014 22:42'!
retailDropList
	^self dropListZeroToNine ! !

!BitizenMorph methodsFor: 'get index' stamp: 'HwaJong 2/23/2014 22:42'!
retailDropListIndex
	^self dropListIndexWithAbilityGetter: #retailAbility! !

!BitizenMorph methodsFor: 'set index' stamp: 'HwaJong 2/23/2014 22:42'!
retailDropListIndex: anInteger 
	self dropListIndex: anInteger abilitySetter: #retailAbility:! !

!BitizenMorph methodsFor: 'droplist' stamp: 'HwaJong 2/23/2014 22:42'!
serviceDropList
	^self dropListZeroToNine! !

!BitizenMorph methodsFor: 'get index' stamp: 'HwaJong 2/23/2014 22:42'!
serviceDropListIndex
	^self dropListIndexWithAbilityGetter: #serviceAbility! !

!BitizenMorph methodsFor: 'set index' stamp: 'HwaJong 2/23/2014 22:42'!
serviceDropListIndex: anInteger 
	self dropListIndex: anInteger abilitySetter: #serviceAbility:! !

DialogWindow subclass: #BitizenDialogWindow
	instanceVariableNames: 'morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!BitizenDialogWindow methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/23/2014 23:56'!
initialExtent
	^ 270 @ 245! !

!BitizenDialogWindow methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/23/2014 23:25'!
model
	^morph model! !

!BitizenDialogWindow methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/23/2014 23:23'!
model: aBitizen
	morph model: aBitizen! !

!BitizenDialogWindow methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/23/2014 23:22'!
newContentMorph
	morph := BitizenMorph new beSpaceFilling.
	^morph! !

Error subclass: #TTJobInUse
	instanceVariableNames: 'job'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!TTJobInUse methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/16/2014 19:55'!
job: aTTJob 
	job := aTTJob ! !

Error subclass: #TTNoJobError
	instanceVariableNames: 'jobName game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!TTNoJobError methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 17:50'!
addJobAndRetry
	game addJobNamed: jobName.
	(game hasJobNamed: jobName)
		ifTrue: [ self retry ]! !

!TTNoJobError methodsFor: 'as yet unclassified ' stamp: 'HwaJong 2/15/2014 23:53'!
game
	^ game! !

!TTNoJobError methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 23:26'!
game: aTinyTowerGame 
	game := aTinyTowerGame ! !

!TTNoJobError methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 23:53'!
jobName
	^ jobName! !

!TTNoJobError methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 23:16'!
jobName: aString 

	jobName := aString! !

!UndefinedObject methodsFor: '*TinyTower' stamp: 'HwaJong 3/31/2014 21:15'!
isHealthy
	^true! !

GGListController subclass: #BitizenListController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!BitizenListController methodsFor: 'list-action' stamp: 'HwaJong 3/27/2014 15:39'!
addItem

	| dw |
	dw := BitizenDialogWindow new.
	dw model: (Bitizen new game: ownerController model).
	UIManager default openModal: dw.
	^dw cancelled
		ifTrue: 
			[nil]
		ifFalse: 
			[ownerController model addBitizen: (dw model).
			self refreshListAndSelect: dw model.
			self changed: #summaryString.
			dw model]! !

!BitizenListController methodsFor: 'list-protocol' stamp: 'HwaJong 3/13/2014 19:51'!
arrayOfStringsForListMorphOfElement: anObject
	^{
		anObject bitName. 
		anObject jobFloor ifNil: [ 'nil' ] ifNotNil: [:that| 'job ', that number printString ].
		anObject homeFloor ifNil: [ 'nil' ] ifNotNil: [:that| 'home ', that number printString ].
		anObject dreamJob ifNil: [ 'nil' ] ifNotNil: [:that| 'dream ', that jobName ]. 
		anObject foodAbility printString. 
		anObject serviceAbility printString. 
		anObject recreationAbility printString. 
		anObject retailAbility printString. 
		anObject creativeAbility printString. 
	}! !

!BitizenListController methodsFor: 'updating widgets' stamp: 'HwaJong 3/27/2014 15:44'!
changedWhenItemRemoved
	self ownerController floorListController refreshListMaintainingSelection.
	self detailController updateWithModel.
	self changed: #summaryString.! !

!BitizenListController methodsFor: 'list-protocol' stamp: 'HwaJong 3/13/2014 21:11'!
filteredCollectionForListModel
	|upper|
	upper := self filterString asUppercase.
	^ownerController model bitizens select: [:each| upper isEmpty or: [(each bitName findString: upper) > 0] ]! !

!BitizenListController methodsFor: 'accessing' stamp: 'HwaJong 3/27/2014 15:38'!
morph
	|q|
	q := QuickPrototyping for: self.
	^q column: 
		{
			self filterTextMorph: q. 
			self listMorph: q.
			q row: 
				{self addItemButton: q.
				self removeItemButton: q.
				self itemSortingDropList: q.
				self inspectControllerButton: q.
				self inspectButton: q}.
			q row: {q label: #summaryString }.
		}! !

!BitizenListController methodsFor: 'defaults' stamp: 'HwaJong 3/18/2014 10:52'!
pageControllerClassesForPolymorphicPageController

	^{BitizenDetailController}! !

!BitizenListController methodsFor: 'list-protocol' stamp: 'HwaJong 3/13/2014 20:05'!
removalSelector
	^#removeBitizen:! !

!BitizenListController methodsFor: 'defaults' stamp: 'HwaJong 3/13/2014 20:52'!
sortingDescriptorsDefault

	^{ 
			PrintingDifferently subject: (UnarySortDescriptor ascendingBy: #bitName) printOnBlockWithSelfWithStream: [:me :stream | stream nextPutAll: 'name' ].
			PrintingDifferently subject: (UnarySortDescriptor ascendingBy: #happiness) printOnBlockWithSelfWithStream: [:me :stream | stream nextPutAll: 'happiness' ].
			PrintingDifferently subject: (UnarySortDescriptor descendingBy: #foodAbility) printOnBlockWithSelfWithStream: [:me :stream | stream nextPutAll: 'food' ].
			PrintingDifferently subject: (UnarySortDescriptor descendingBy: #serviceAbility) printOnBlockWithSelfWithStream: [:me :stream | stream nextPutAll: 'service' ].
			PrintingDifferently subject: (UnarySortDescriptor descendingBy: #recreationAbility) printOnBlockWithSelfWithStream: [:me :stream | stream nextPutAll: 'recreation' ].
			PrintingDifferently subject: (UnarySortDescriptor descendingBy: #retailAbility) printOnBlockWithSelfWithStream: [:me :stream | stream nextPutAll: 'retail' ].
			PrintingDifferently subject: (UnarySortDescriptor descendingBy: #creativeAbility) printOnBlockWithSelfWithStream: [:me :stream | stream nextPutAll: 'creative' ].
			PrintingDifferently subject: (UnarySortDescriptor descendingBy: #homeFloorNumber) printOnBlockWithSelfWithStream: [:me :stream | stream nextPutAll: 'home' ].
	}! !

!BitizenListController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/27/2014 15:41'!
summaryString
	|bs|
	bs := ownerController model bitizens size.
	^bs printString, ' bitizen',(bs>1 ifTrue: ['s'] ifFalse: [''])! !

GGListController subclass: #BitizenListOfFloorController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

BitizenListOfFloorController subclass: #BitizenListOfCommercialFloorController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!BitizenListOfCommercialFloorController methodsFor: 'adding' stamp: 'HwaJong 3/27/2014 15:58'!
addItem
	|cb|
	cb := ChooseFromBuilder new.
	cb title: 'select bitizen to employ'.
	self model game unemployedBitizens do: [:each| 
		cb choiceString: (each bitName, ' ', (self model job meaningfulAbilityOfBitizen: each) printString, ' ', (each dreamJob == self model job ifTrue: ['dream'] ifFalse: [''])) value: 
			[self model addBitizen: each.
			ownerController
				ifNotNil: [:that| that refreshSelection].
			self refreshListAndSelect: each.
			self ownerController ownerController bitizenListController refreshListMaintainingSelection] ].
	cb chooseFromValuesTitle.! !

!BitizenListOfCommercialFloorController methodsFor: 'list-protocol' stamp: 'HwaJong 3/16/2014 17:33'!
arrayOfStringsForListMorphOfElement: aBitizen 
	^{
		aBitizen bitName. 
		aBitizen abilityOfEmployedJob printString. 
		aBitizen gotDreamJobString
	}! !

!BitizenListOfCommercialFloorController methodsFor: 'testing' stamp: 'HwaJong 3/17/2014 20:01'!
canPresent: aFloor 
	^aFloor isKindOf: CommercialFloor! !

!BitizenListOfCommercialFloorController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/29/2014 11:58'!
jobColor
	^[self model job jobColor] on: SubscriptOutOfBounds do: [ :exp| Color black ]! !

!BitizenListOfCommercialFloorController methodsFor: 'morph' stamp: 'HwaJong 3/29/2014 12:00'!
morph
	|q|
	q := QuickPrototyping for: self.
	^q column: 
		{q title: 'production' label: #productionEfficiencyString.
		(q staticColor: #jobColor) beHorizontalFillingWithHeight: 24.
		self listMorph: q.
		q row: 
			{self addItemButton: q.
			self removeItemButton: q.
			q button: 'up' action: #moveUpSelectedBitizen enabled: #itemIsSelected.
			q button: 'down' action: #moveDownSelectedBitizen enabled: #itemIsSelected.
			q button: 'show' action: #showSelectedBitizen enabled: #itemIsSelected}}! !

!BitizenListOfCommercialFloorController methodsFor: 'updating widgets' stamp: 'HwaJong 3/29/2014 11:58'!
operationWhenSelectionIsChanged

	super operationWhenSelectionIsChanged.
	self changed: #productionEfficiencyString.
	self changed: #jobColor.
! !

!BitizenListOfCommercialFloorController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/25/2014 21:24'!
productionEfficiencyString
	^ownerController listModel
		ifHasSelection: [:selectedFloor| |num|
			num := selectedFloor productionEfficiency.
			num isNaN
				ifTrue: ['0']
				ifFalse: [(num * 100.0) rounded printString, '%'] ]
		ifDoesNotHaveSelection:  [ 'N/A' ]! !

!BitizenListOfFloorController methodsFor: 'testing' stamp: 'HwaJong 3/16/2014 20:09'!
canAddItem
	^self ownerController listModel 
		ifHasSelection: [:selection| selection bitizenOrderedCollection size < selection maxPopulation  ] 
		ifDoesNotHaveSelection: [ false ]! !

!BitizenListOfFloorController methodsFor: 'updating widgets' stamp: 'HwaJong 3/16/2014 20:02'!
changedWhenItemRemoved
	ownerController ifNotNil: [ :that| that refreshElements ].
	self changed: #canAddItem.! !

!BitizenListOfFloorController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/22/2014 21:19'!
detailControllerPriority
	^9999! !

!BitizenListOfFloorController methodsFor: 'list-protocol' stamp: 'HwaJong 3/16/2014 20:09'!
filteredCollectionForListModel
	^self ownerController listModel
		ifHasSelection: [:sel | sel bitizenOrderedCollection ] 
		ifDoesNotHaveSelection: [ Array new ]! !

!BitizenListOfFloorController methodsFor: 'morph' stamp: 'HwaJong 3/17/2014 20:11'!
morph
	|q|
	q := QuickPrototyping for: self.
	^q column: 
		{self listMorph: q.
		q row: 
			{self addItemButton: q.
			self removeItemButton: q.
			q button: 'up' action: #moveUpSelectedBitizen enabled: #itemIsSelected.
			q button: 'down' action: #moveDownSelectedBitizen enabled: #itemIsSelected.}}! !

!BitizenListOfFloorController methodsFor: 'actions' stamp: 'HwaJong 3/20/2014 19:41'!
moveDownSelectedBitizen
	self model moveDownBitizen: self listModel selection.
	ownerController refresh! !

!BitizenListOfFloorController methodsFor: 'actions' stamp: 'HwaJong 3/20/2014 19:41'!
moveUpSelectedBitizen
	self model moveUpBitizen: self listModel selection.
	ownerController refresh! !

!BitizenListOfFloorController methodsFor: 'actions' stamp: 'HwaJong 3/17/2014 10:57'!
removeSelectedItem
	self model removeBitizen: (self listModel selection).
	self refreshList.
	self changedWhenItemRemoved.! !

!BitizenListOfFloorController methodsFor: 'as yet unclassified ' stamp: 'HwaJong 3/25/2014 10:55'!
showSelectedBitizen
	ownerController ownerController showBitizen: self listModel selection ! !

BitizenListOfFloorController subclass: #BitizenListOfResidentFloorController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!BitizenListOfResidentFloorController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/17/2014 11:34'!
addItem
	|cb|
	cb := ChooseFromBuilder new.
	cb title: 'select bitizen to live here'.
	self model game homelessBitizens do: [:each| 
		cb choiceString: each bitName value: 
			[self model addBitizen: each.
			ownerController ifNotNil: [:that| that refreshSelection].
			self refreshListAndSelect: each.
			self ownerController ownerController bitizenListController refreshListMaintainingSelection] ].
	cb chooseFromValuesTitle.! !

!BitizenListOfResidentFloorController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/23/2014 10:01'!
arrayOfStringsForListMorphOfElement: aBitizen 
	^{aBitizen bitName. aBitizen emoticon. aBitizen employmentString}! !

!BitizenListOfResidentFloorController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/17/2014 20:01'!
canPresent: aFloor 
	^aFloor isKindOf: ResidentFloor! !

!BitizenListOfResidentFloorController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/25/2014 10:56'!
morph
	|q|
	q := QuickPrototyping for: self.
	^q column: 
		{self listMorph: q.
		q row: 
			{self addItemButton: q.
			self removeItemButton: q.
			q button: 'up' action: #moveUpSelectedBitizen enabled: #itemIsSelected.
			q button: 'down' action: #moveDownSelectedBitizen enabled: #itemIsSelected.
			q button: 'show' action: #showSelectedBitizen enabled: #itemIsSelected}}! !

GGListController subclass: #FloorListController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!FloorListController commentStamp: '' prior: 0!
A BitizenListController is xxxxxxxxx.

Instance Variables
	detailController:		<Object>
	filterString:		<Object>
	listModel:		<Object>
	ownerController:		<Object>
	sortingDescriptorListModel:		<Object>

detailController
	- xxxxx

filterString
	- xxxxx

listModel
	- xxxxx

ownerController
	- xxxxx

sortingDescriptorListModel
	- xxxxx
!

!FloorListController methodsFor: 'adding' stamp: 'HwaJong 3/18/2014 11:28'!
addCommercialFloor
	| cb |
	cb := ChooseFromBuilder new.
	cb title: 'select job of commerical floor', (ownerController model floors size + 1) printString.
	ownerController model unflooredJobs do: 
		[:each| 
		cb choiceString: each jobName value: 
			[ownerController model addFloor: (CommercialFloor new job: each).
			self updateListAfterAddingItem.
			ownerController missionListController refreshListMaintainingSelection] ].
	cb chooseFromValuesTitle.
	! !

!FloorListController methodsFor: 'adding' stamp: 'HwaJong 3/13/2014 00:13'!
addItem
	| menu |
	menu := MenuMorph new.
	menu add: 'commercial' target: self action: #addCommercialFloor.
	menu add: 'resident' target: self action: #addResidentFloor.
	menu popUpInWorld: self currentWorld.! !

!FloorListController methodsFor: 'adding' stamp: 'HwaJong 3/18/2014 11:28'!
addResidentFloor
	ownerController model addReisdentalFloor.
	self updateListAfterAddingItem.! !

!FloorListController methodsFor: 'list' stamp: 'HwaJong 3/13/2014 20:19'!
arrayOfStringsForListMorphOfElement: anObject
	^{
		anObject number printString. 
		anObject summaryString
	}! !

!FloorListController methodsFor: 'updating widgets' stamp: 'HwaJong 3/17/2014 11:33'!
changedWhenItemRemoved
	ownerController missionListController refreshListMaintainingSelection.! !

!FloorListController methodsFor: 'list' stamp: 'HwaJong 3/15/2014 15:10'!
filteredCollectionForListModel
	|upper|
	upper := self filterString asUppercase.
	^ownerController model floors reverse select: [:each| upper isEmpty or: [each isCommercialFloor and: [(each jobName findString: upper) > 0]] ]! !

!FloorListController methodsFor: 'accessing' stamp: 'HwaJong 3/16/2014 20:40'!
morph
	|q|
	q := QuickPrototyping for: self.
	^q column: 
		{self filterTextMorph: q. 
		self listMorph: q.
		q row: 
			{self addItemButton: q.
			self removeItemButton: q.
			self inspectButton: q.}}! !

!FloorListController methodsFor: 'defaults' stamp: 'HwaJong 3/25/2014 00:06'!
pageControllerClassesForPolymorphicPageController
	^{
		BitizenListOfCommercialFloorController . 
		BitizenListOfResidentFloorController . 
		LoungeDetailController . 
	}! !

!FloorListController methodsFor: 'list-protocol' stamp: 'HwaJong 3/13/2014 20:10'!
removalSelector
	^#removeFloor:! !

!FloorListController methodsFor: 'updating widgets' stamp: 'HwaJong 3/18/2014 19:24'!
updateListAfterAddingItem
	self refreshListAndSelect: ownerController model floors last! !

GGListController subclass: #IssueListController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!IssueListController commentStamp: '' prior: 0!
A BitizenListController is xxxxxxxxx.
!

!IssueListController methodsFor: 'list' stamp: 'HwaJong 3/13/2014 19:47'!
arrayOfStringsForListMorphOfElement: anObject
	^{
		anObject printString
	}! !

!IssueListController methodsFor: 'list' stamp: 'HwaJong 4/2/2014 03:01'!
filteredCollectionForListModel

	^Array streamContents: 
			[:stream|
				ownerController model overcrowdedDreamJobAssociations do: [ :jobToBitizens|
					((jobToBitizens value asSortedCollection: (UnarySortDescriptor descendingBy: #abilityOfDreamJob)) allButFirst: 3)
						do: [ :toEvict | 
							(stream contents allSatisfy: [:hi| (hi suppressesAction: toEvict) not ])
								ifTrue: [stream nextPut: (TTEvictBitizenAction new bitizen: toEvict; reason: 'overcrowded dreamjob')] ]].
				ownerController model bitizensWhoCanGetTheirDreamJob do: 
					[ :each| 
						| a |
						a := TTCanGetDreamJobAction new bitizen: each.
						(stream contents allSatisfy: [:hi| (hi suppressesAction: a) not ])
							ifTrue: [stream nextPut: a] ].
				ownerController model floorsNeedingBitizen do: [ :each|
					stream nextPut: (TTFloorNeedsBitizenAction new floor: each) ].
				ownerController model replaceWorseEmployedBitizenWithBetterUnemployedBitizenToWinActions
					do: [:each| 
						(stream contents allSatisfy: [:hi| (hi suppressesAction: each) not ])
							ifTrue: [stream nextPut: each]].
				ownerController model missionsNotDoneYetButCanBeDone do: [ :each| stream nextPut: (TTDoMissionAction new mission: each)].
				stream nextPut: (TTNotFunctioningStringAction string: 'elevator ppm should be at least ', ownerController model leastElevatorPpmRequired printString).
			]! !

!IssueListController methodsFor: 'accessing' stamp: 'HwaJong 3/21/2014 13:24'!
morph
	|q|
	q := QuickPrototyping for: self.
	^q column: 
		{self listMorph: q. 
		q row: 
			{self refreshListButton: q. 
			self inspectButton: q.
			self inspectDetailControllerButton: q}}.! !

!IssueListController methodsFor: 'defaults' stamp: 'HwaJong 3/29/2014 09:35'!
pageControllerClassesForPolymorphicPageController

	^{TTCanGetDreamJobActionDetailController. ShowBitizenIssueDetailController. ShowFloorIssueDetailController. MissionIssueDetailController. ReplaceBitizenIssueDetailController. TTNotFunctioningStringActionDetailController. TTEvictBitizenActionDetailController}! !

GGListController subclass: #JobListController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!JobListController commentStamp: '' prior: 0!
A BitizenListController is xxxxxxxxx.

Instance Variables
	detailController:		<Object>
	filterString:		<Object>
	listModel:		<Object>
	ownerController:		<Object>
	sortingDescriptorListModel:		<Object>

detailController
	- xxxxx

filterString
	- xxxxx

listModel
	- xxxxx

ownerController
	- xxxxx

sortingDescriptorListModel
	- xxxxx
!

!JobListController methodsFor: 'adding' stamp: 'HwaJong 3/15/2014 15:47'!
addItem
	| draftJobName uppercaseJobName |
	draftJobName := UIManager default request: 'name of new job'.
	draftJobName isEmptyOrNil ifTrue: [ ^ownerController ].
	uppercaseJobName := draftJobName asUppercase.
	uppercaseJobName
		isEmptyOrNil
			ifFalse: [
				| job | 
				job := ownerController model addJobNamed: uppercaseJobName.
				self refreshListAndSelect: job]! !

!JobListController methodsFor: 'list' stamp: 'HwaJong 3/13/2014 19:48'!
arrayOfStringsForListMorphOfElement: anObject

	^{
		Text string: anObject jobName attribute: (TextColor new color: anObject jobColor). 
		anObject class typeName 
	}! !

!JobListController methodsFor: 'updating widgets' stamp: 'HwaJong 3/13/2014 20:13'!
changedWhenItemRemoved! !

!JobListController methodsFor: 'list' stamp: 'HwaJong 3/13/2014 21:15'!
filteredCollectionForListModel
	|upper|
	upper := self filterString asUppercase.
	^ownerController model jobs select: [:each| upper isEmpty or: [(each jobName findString: upper) > 0] ]! !

!JobListController methodsFor: 'accessing' stamp: 'HwaJong 3/16/2014 19:51'!
morph
	|q|
	q := QuickPrototyping for: self.
	^q column: 
		{self filterTextMorph: q.
		self listMorph: q.
		q row: 
			{self addItemButton: q. 
			self removeItemButton: q.
			q button: 'rename' action: #renameItemName enabled: #itemIsSelected}}! !

!JobListController methodsFor: 'defaults' stamp: 'HwaJong 3/18/2014 11:58'!
pageControllerClassesForPolymorphicPageController

	^{JobDetailController}! !

!JobListController methodsFor: 'list-protocol' stamp: 'HwaJong 3/13/2014 21:06'!
removalSelector
	^#removeJob:! !

!JobListController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/15/2014 15:43'!
renameItemName
	| job newJobName|
	job := self listModel selection.
	newJobName := UIManager default request: 'job name' initialAnswer: job jobName.
	newJobName isEmptyOrNil
		ifFalse: 
			[job jobName: newJobName.
			self refreshSelection ]! !

!JobListController methodsFor: 'defaults' stamp: 'HwaJong 3/13/2014 20:53'!
sortingDescriptorsDefault

	^{ 
		UnarySortDescriptor ascendingBy: #jobName.
	}! !

GGListController subclass: #MissionDotRequiredJobListController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!MissionDotRequiredJobListController methodsFor: 'list-action' stamp: 'HwaJong 3/30/2014 18:25'!
addItem
	| cb |
	cb := ChooseFromBuilder new.
	cb title: 'add to required job'.
	ownerController ownerController ownerController model jobs do:
		[:each|
		cb choiceString: each jobName value: 
			["ownerController model requiredJobs add: each."
			ownerController model addRequiredJobs: each.
			self refreshFromRootController]].
	cb chooseFromValuesTitle.! !

!MissionDotRequiredJobListController methodsFor: 'list-protocol' stamp: 'HwaJong 3/18/2014 20:06'!
arrayOfStringsForListMorphOfElement: aTTJob 
	^{
		aTTJob jobName. 
	}! !

!MissionDotRequiredJobListController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/19/2014 21:01'!
changedWhenItemRemoved
	self refreshFromRootController! !

!MissionDotRequiredJobListController methodsFor: 'list-protocol' stamp: 'HwaJong 3/18/2014 20:04'!
filteredCollectionForListModel
	^ownerController ownerController listModel
		ifHasSelection: [:selectedMission| selectedMission requiredJobs ] 
		ifDoesNotHaveSelection:  [ Array new ]! !

!MissionDotRequiredJobListController methodsFor: 'morph' stamp: 'HwaJong 3/18/2014 20:02'!
morph
	|q|
	q := QuickPrototyping for: self.
	^q column:
		{self listMorph: q.
		q row: 
			{self addItemButton: q.
			self removeItemButton: q.}}! !

!MissionDotRequiredJobListController methodsFor: 'list-protocol' stamp: 'HwaJong 3/18/2014 20:24'!
removalSelector
	^#removeRequiredJob:! !

GGListController subclass: #MissionListController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!MissionListController commentStamp: '' prior: 0!
A BitizenListController is xxxxxxxxx.

Instance Variables
	detailController:		<Object>
	filterString:		<Object>
	listModel:		<Object>
	ownerController:		<Object>
	sortingDescriptorListModel:		<Object>

detailController
	- xxxxx

filterString
	- xxxxx

listModel
	- xxxxx

ownerController
	- xxxxx

sortingDescriptorListModel
	- xxxxx
!

!MissionListController methodsFor: 'adding' stamp: 'HwaJong 3/30/2014 17:57'!
addItem
	| ms |
	ms := TTMission new.
	ownerController model addMission: ms.
	self refreshListAndSelect: ms.
	self changed: #summaryString.! !

!MissionListController methodsFor: 'list' stamp: 'HwaJong 3/13/2014 19:52'!
arrayOfStringsForListMorphOfElement: anObject
	^{
		anObject ordinalNumber printString. 
		anObject name. 
		anObject availableString. 
		anObject doneString 
	}! !

!MissionListController methodsFor: 'updating widgets' stamp: 'HwaJong 3/27/2014 15:31'!
changedWhenItemRemoved
	self refreshListMaintainingSelection.
	self changed: #summaryString! !

!MissionListController methodsFor: 'updating widgets' stamp: 'HwaJong 3/30/2014 10:24'!
changedWhenRefreshList
	self changed: #summaryString! !

!MissionListController methodsFor: 'list' stamp: 'HwaJong 3/13/2014 21:16'!
filteredCollectionForListModel
	|upper|
	upper := self filterString asUppercase.
	^ownerController model missions select: [:each| upper isEmpty or: [(each name findString: upper) > 0] ] ! !

!MissionListController methodsFor: 'accessing' stamp: 'HwaJong 3/27/2014 15:29'!
morph
	|q|
	q := QuickPrototyping for: self.
	^q column: 
		{self filterTextMorph: q.
		self listMorph: q.
		q row: 
			{self inspectButton: q.
			self refreshListButton: q.
			q button: 'reorder' action: #reorderMissions.
			self addItemButton: q.
			self removeItemButton: q}.
		q row: {q label: #summaryString }. }! !

!MissionListController methodsFor: 'defaults' stamp: 'HwaJong 3/18/2014 11:23'!
pageControllerClassesForPolymorphicPageController

	^{MissionDetailController}! !

!MissionListController methodsFor: 'list-protocol' stamp: 'HwaJong 3/13/2014 20:14'!
removalSelector
	^#removeMission:! !

!MissionListController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/15/2014 15:44'!
reorderMissions
	self listModel list keysAndValuesDo: 
		[ :index :mission |
		mission ordinalNumber: index * 10].
	self refreshElements! !

!MissionListController methodsFor: 'defaults' stamp: 'HwaJong 3/13/2014 20:53'!
sortingDescriptorsDefault

	^{ 
		UnarySortDescriptor ascendingBy: #ordinalNumber.
	}! !

!MissionListController methodsFor: 'string' stamp: 'HwaJong 3/27/2014 15:29'!
summaryString

	^((self listModel list) count: #isDone) printString, ' missions done.'.
! !

TestCase subclass: #BitizenCollectionTest
	instanceVariableNames: 'bCol'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

BitizenCollectionTest subclass: #BitizenCollection1K1Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!BitizenCollection1K1Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 12:00'!
bitizen1
	
	^Bitizen new 
		bitName: 'JOSE SPENCER'; 
		dreamJob: (RecreationJob new jobName: 'AQUARIUM'); 
		foodAbility: 5;
		serviceAbility: 0;
		recreationAbility: 8;
		retailAbility: 3;
		creativeAbility: 1! !

!BitizenCollection1K1Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 12:00'!
setUp
	super setUp.
	(self class selectors select: [ :each| each beginsWith: 'bitizen' ]) do: [:each| bCol addBitizen: (self perform: each)].! !

!BitizenCollection1K1Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 12:12'!
testAbilityTypeNameOfBestAbilitySum
	self assert: bCol abilityTypeNameOfBestAbilitySum equals: #recreation! !

!BitizenCollection1K1Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 12:14'!
testAbilityTypeNameOfMostDreamJob
	self assert: bCol abilityTypeNameOfMostDreamJob equals: #recreation! !

!BitizenCollection1K1Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 11:37'!
testCreativeAbilitySum
	self assert: bCol creativeAbilitySum equals: 1! !

!BitizenCollection1K1Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 11:27'!
testFoodAbilitySum
	self assert: bCol foodAbilitySum equals: 5! !

!BitizenCollection1K1Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 11:30'!
testRecreationAbilitySum
	self assert: bCol recreationAbilitySum equals: 8! !

!BitizenCollection1K1Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 11:36'!
testRetailAbilitySum
	self assert: bCol retailAbilitySum equals: 3! !

!BitizenCollection1K1Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 11:28'!
testServiceAbilitySum
	self assert: bCol serviceAbilitySum equals: 0! !

!BitizenCollection1K1Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 11:26'!
testSetUp
	super testSetUp.
	self assert: bCol bitizens size equals: 1! !

BitizenCollectionTest subclass: #BitizenCollection1K2Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!BitizenCollection1K2Test commentStamp: '' prior: 0!
A BitizenCollection1K1Test is xxxxxxxxx.
!

!BitizenCollection1K2Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 12:17'!
bitizen1
	
	^Bitizen new 
		bitName: 'JOSE SPENCER'; 
		dreamJob: (FoodJob new jobName: 'DINER'); 
		foodAbility: 5;
		serviceAbility: 0;
		recreationAbility: 8;
		retailAbility: 3;
		creativeAbility: 1! !

!BitizenCollection1K2Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 12:16'!
setUp
	super setUp.
	(self class selectors select: [ :each| each beginsWith: 'bitizen' ]) do: [:each| bCol addBitizen: (self perform: each)].! !

!BitizenCollection1K2Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 12:16'!
testAbilityTypeNameOfBestAbilitySum
	self assert: bCol abilityTypeNameOfBestAbilitySum equals: #recreation! !

!BitizenCollection1K2Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 12:17'!
testAbilityTypeNameOfMostDreamJob
	self assert: bCol abilityTypeNameOfMostDreamJob equals: #food! !

!BitizenCollection1K2Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 12:16'!
testCreativeAbilitySum
	self assert: bCol creativeAbilitySum equals: 1! !

!BitizenCollection1K2Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 12:16'!
testFoodAbilitySum
	self assert: bCol foodAbilitySum equals: 5! !

!BitizenCollection1K2Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 12:16'!
testRecreationAbilitySum
	self assert: bCol recreationAbilitySum equals: 8! !

!BitizenCollection1K2Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 12:16'!
testRetailAbilitySum
	self assert: bCol retailAbilitySum equals: 3! !

!BitizenCollection1K2Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 12:16'!
testServiceAbilitySum
	self assert: bCol serviceAbilitySum equals: 0! !

!BitizenCollection1K2Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 12:16'!
testSetUp
	super testSetUp.
	self assert: bCol bitizens size equals: 1! !

BitizenCollectionTest subclass: #BitizenCollection2Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!BitizenCollection2Test commentStamp: '' prior: 0!
A BitizenCollection1Test is xxxxxxxxx.
!

!BitizenCollection2Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 11:59'!
bitizen1
	
	^Bitizen new 
		bitName: 'JOSE SPENCER'; 
		dreamJob: (RecreationJob new jobName: 'AQUARIUM'); 
		foodAbility: 5;
		serviceAbility: 0;
		recreationAbility: 8;
		retailAbility: 3;
		creativeAbility: 1! !

!BitizenCollection2Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 11:59'!
bitizen2
	^Bitizen new 
		bitName: 'DEANNA PRICE'; 
		dreamJob: (RecreationJob new jobName: 'ARCHERY RANGE'); 
		foodAbility: 4;
		serviceAbility: 1;
		recreationAbility: 4;
		retailAbility: 1;
		creativeAbility: 4! !

!BitizenCollection2Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 11:59'!
setUp
	super setUp.
	(self class selectors select: [ :each| each beginsWith: 'bitizen' ]) do: [:each| bCol addBitizen: (self perform: each)].! !

!BitizenCollection2Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 12:12'!
testAbilityTypeNameOfBestAbilitySum
	self assert: bCol abilityTypeNameOfBestAbilitySum equals: #recreation! !

!BitizenCollection2Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 12:14'!
testAbilityTypeNameOfMostDreamJob
	self assert: bCol abilityTypeNameOfMostDreamJob equals: #recreation! !

!BitizenCollection2Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 11:48'!
testCreativeAbilitySum
	self assert: bCol creativeAbilitySum equals: 5! !

!BitizenCollection2Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 11:48'!
testFoodAbilitySum
	self assert: bCol foodAbilitySum equals: 9! !

!BitizenCollection2Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 11:47'!
testRecreationAbilitySum
	self assert: bCol recreationAbilitySum equals: 12! !

!BitizenCollection2Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 11:49'!
testRetailAbilitySum
	self assert: bCol retailAbilitySum equals: 4! !

!BitizenCollection2Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 11:49'!
testServiceAbilitySum
	self assert: bCol serviceAbilitySum equals: 1! !

!BitizenCollection2Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 11:49'!
testSetUp
	super testSetUp.
	self assert: bCol bitizens size equals: 2! !

BitizenCollectionTest subclass: #BitizenCollection5Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!BitizenCollection5Test commentStamp: '' prior: 0!
A BitizenCollection1Test is xxxxxxxxx.
!

!BitizenCollection5Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 11:54'!
bitizen1
	
	^Bitizen new 
		bitName: 'JOSE SPENCER'; 
		dreamJob: (RecreationJob new jobName: 'AQUARIUM'); 
		foodAbility: 5;
		serviceAbility: 0;
		recreationAbility: 8;
		retailAbility: 3;
		creativeAbility: 1! !

!BitizenCollection5Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 11:57'!
bitizen2
	^Bitizen new 
		bitName: 'DEANNA PRICE'; 
		dreamJob: (RecreationJob new jobName: 'ARCHERY RANGE'); 
		foodAbility: 4;
		serviceAbility: 1;
		recreationAbility: 4;
		retailAbility: 1;
		creativeAbility: 4! !

!BitizenCollection5Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 11:58'!
bitizen3
	^Bitizen new 
		bitName: 'DARRYL BLACK'; 
		dreamJob: (RetailJob new jobName: 'GAME STORE'); 
		foodAbility: 5;
		serviceAbility: 3;
		recreationAbility: 1;
		retailAbility: 6;
		creativeAbility: 4! !

!BitizenCollection5Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 12:01'!
bitizen4
	^Bitizen new 
		bitName: 'EVA PATTERSON'; 
		dreamJob: (RecreationJob new jobName: 'BILLIARD HALL'); 
		foodAbility: 4;
		serviceAbility: 1;
		recreationAbility: 4;
		retailAbility: 1;
		creativeAbility: 4! !

!BitizenCollection5Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 12:02'!
bitizen5
	^Bitizen new 
		bitName: 'SUZANNE HENRY'; 
		dreamJob: (FoodJob new jobName: 'ITALIAN FOOD'); 
		foodAbility: 6;
		serviceAbility: 2;
		recreationAbility: 4;
		retailAbility: 0;
		creativeAbility: 2! !

!BitizenCollection5Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 11:59'!
setUp
	super setUp.
	(self class selectors select: [ :each| each beginsWith: 'bitizen' ]) do: [:each| bCol addBitizen: (self perform: each)].! !

!BitizenCollection5Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 12:12'!
testAbilityTypeNameOfBestAbilitySum
	self assert: bCol abilityTypeNameOfBestAbilitySum equals: #food! !

!BitizenCollection5Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 12:14'!
testAbilityTypeNameOfMostDreamJob
	self assert: bCol abilityTypeNameOfMostDreamJob equals: #recreation! !

!BitizenCollection5Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 12:03'!
testCreativeAbilitySum
	self assert: bCol creativeAbilitySum equals: 15! !

!BitizenCollection5Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 12:03'!
testFoodAbilitySum
	self assert: bCol foodAbilitySum equals: 24! !

!BitizenCollection5Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 12:03'!
testRecreationAbilitySum
	self assert: bCol recreationAbilitySum equals: 21! !

!BitizenCollection5Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 12:01'!
testRetailAbilitySum
	self assert: bCol retailAbilitySum equals: 11! !

!BitizenCollection5Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 12:03'!
testServiceAbilitySum
	self assert: bCol serviceAbilitySum equals: 7! !

!BitizenCollection5Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 12:03'!
testSetUp
	super testSetUp.
	self assert: bCol bitizens size equals: 5! !

!BitizenCollectionTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 11:16'!
setUp
	super setUp.
	bCol := BitizenCollection new! !

!BitizenCollectionTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 11:24'!
testAddBitizen
	| bitizen |
	bitizen := Bitizen new 
		bitName: 'JOSE SPENCER'; 
		dreamJob: (RecreationJob new jobName: 'AQUARIUM'); 
		foodAbility: 5;
		serviceAbility: 0;
		recreationAbility: 8;
		retailAbility: 3;
		creativeAbility: 1.
	bCol addBitizen: bitizen.! !

!BitizenCollectionTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 11:26'!
testSetUp
	self assert: bCol notNil! !

TestCase subclass: #TinyTowerGameTest
	instanceVariableNames: 'game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!TinyTowerGameTest methodsFor: 'running' stamp: 'HwaJong 3/5/2014 18:56'!
setUp
	super setUp.
	game := TinyTowerGame new.! !

!TinyTowerGameTest methodsFor: 'tests' stamp: 'HwaJong 4/2/2014 15:29'!
testChangeFoodAbilityButBitizenStillAccessable
	| bit |
	bit := Bitizen new bitName: 'papa'.
	bit foodAbility: 9.
	game addBitizen: bit.
	self assert: (game bitizens includes: bit).
	
	bit foodAbility: 8.
	self assert: (game bitizens includes: bit).! !

!TinyTowerGameTest methodsFor: 'tests' stamp: 'HwaJong 3/30/2014 18:14'!
testGameGetsDirtyByBitizen
	|b|
	b := Bitizen new bitName: 'tilda'.
	game addBitizen: b.
	self assert: game docLogic hasUnsavedChange.
	game docLogic hasUnsavedChange: false.
	self deny: game docLogic hasUnsavedChange.
	b bitName: 'justin'.
	self assert: game docLogic hasUnsavedChange.! !

!TinyTowerGameTest methodsFor: 'tests' stamp: 'HwaJong 3/31/2014 21:30'!
testGameGetsDirtyByJob
	|j|
	j := FoodJob new jobName: 'GRASS'.

	game docLogic hasUnsavedChange: false.
	self deny: game docLogic hasUnsavedChange.
	game addJob: j.
	self assert: game docLogic hasUnsavedChange.
	
	game docLogic hasUnsavedChange: false.
	self deny: game docLogic hasUnsavedChange.
	j jobName: 'DUST'.
	self assert: game docLogic hasUnsavedChange.
	
	game docLogic hasUnsavedChange: false.
	self deny: game docLogic hasUnsavedChange.
	j becomeOfJobClass: ServiceJob.
	self assert: game docLogic hasUnsavedChange.
	
	game docLogic hasUnsavedChange: false.
	self deny: game docLogic hasUnsavedChange.
	game removeJob: j.
	self assert: game docLogic hasUnsavedChange.! !

!TinyTowerGameTest methodsFor: 'tests' stamp: 'HwaJong 3/30/2014 18:29'!
testGameGetsDirtyByMission
	|m j|
	m := TTMission new name: 'vegan party'.
	game addMission: m.
	self assert: game docLogic hasUnsavedChange.
	
	game docLogic hasUnsavedChange: false.
	self deny: game docLogic hasUnsavedChange.
	m ordinalNumber: 10000.
	self assert: game docLogic hasUnsavedChange.
	
	game docLogic hasUnsavedChange: false.
	self deny: game docLogic hasUnsavedChange.
	m name: 'hu la la'.
	self assert: game docLogic hasUnsavedChange.
	
	game docLogic hasUnsavedChange: false.
	self deny: game docLogic hasUnsavedChange.
	j := FoodJob new jobName: 'abc'.
	m addRequiredJob: j.
	self assert: game docLogic hasUnsavedChange.
	
	game docLogic hasUnsavedChange: false.
	self deny: game docLogic hasUnsavedChange.
	m removeRequiredJob: j.
	self assert: game docLogic hasUnsavedChange.
	
	game docLogic hasUnsavedChange: false.
	self deny: game docLogic hasUnsavedChange.
	m isDone: true.
	self assert: game docLogic hasUnsavedChange.! !

!TinyTowerGameTest methodsFor: 'tests' stamp: 'HwaJong 3/5/2014 18:59'!
testRenameBitizenButBitizenStillAccessable
	| bit |
	bit := Bitizen new bitName: 'papa'.
	game addBitizen: bit.
	self assert: (game bitizens includes: bit).
	
	bit bitName: 'mama'.
	self assert: (game bitizens includes: bit).! !

!TinyTowerGameTest methodsFor: 'tests' stamp: 'HwaJong 3/5/2014 19:01'!
testRenameJobButJobStillAccessable
	| job |
	job := CreativeJob new jobName: 'ROBBERY'.
	game addJob: job.
	self assert: (game jobs includes: job).
	
	job jobName: 'CHARITY'.
	self assert: (game jobs includes: job).! !

!TinyTowerGameTest methodsFor: 'tests' stamp: 'HwaJong 3/30/2014 18:37'!
testSetUp
	self assert: game bitizens isEmpty.
	self assert: game floors size equals: 1.
	self assert: game docLogic hasUnsavedChange.! !

GGDetailController subclass: #BitizenDetailController
	instanceVariableNames: 'selectedBititzenMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!BitizenDetailController methodsFor: 'testing' stamp: 'HwaJong 3/18/2014 10:25'!
canPresent: aBitizen 
	^aBitizen isKindOf: Bitizen! !

!BitizenDetailController methodsFor: 'updating' stamp: 'HwaJong 3/17/2014 11:20'!
handleUpdate: aMorphChanged 
	
	(aMorphChanged selector = #bitizenProperty and: [ aMorphChanged morph = selectedBititzenMorph ])
		ifTrue: [ self ownerController refreshElements ]! !

!BitizenDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/19/2014 21:19'!
homeFloorString
	^self ownersListModel
		ifHasSelection: [:bz| 
			bz homeFloor
				ifNil: [ '---' ]
				ifNotNil: [:that| that number printString ] 
			] 
		ifDoesNotHaveSelection: [ '---' ].! !

!BitizenDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/16/2014 18:50'!
ifListHasSelection: aBlockClosure ifListDoesNotHaveSelection: aBlockClosure2 

	^self ownersListModel
		ifHasSelection: aBlockClosure
		ifDoesNotHaveSelection: aBlockClosure2! !

!BitizenDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/19/2014 21:21'!
inspectSelectedBitizen
	self model inspect! !

!BitizenDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/9/2014 00:21'!
jobFloorString
	^self
		ifListHasSelection: [:bz| 
			bz jobFloor
				ifNil: [ '---' ]
				ifNotNil: [:that| that number printString, ' ', that job jobName ] 
			] 
		ifListDoesNotHaveSelection: [ '---' ].! !

!BitizenDetailController methodsFor: 'morph' stamp: 'HwaJong 3/27/2014 15:51'!
morph
	|q|
	q := QuickPrototyping for: self.
	^q column: 
		{selectedBititzenMorph := BitizenMorph new addDependent: self; beSpaceFilling.
		(q 
			groupedRow: 
				{q staticLabel: 'job'. 
				q buttonGetLabel: #jobFloorString action: #setOrClearJobOfSelectedBitizen enabled: #hasModel.
				q button: 'show floor' action: #showJobFloorOfSelectedBitizen enabled: #hasModel})
			beHorizontalFillingWithHeight: 30.
		(q 
			groupedRow: 
				{q staticLabel: 'home'. 
				q buttonGetLabel: #homeFloorString action: #setOrClearHomeOfSelectedBitizen enabled: #hasModel.
				q button: 'show floor' action: #showHomeFloorOfSelectedBitizen enabled: #hasModel})
			beHorizontalFillingWithHeight: 30.
		}! !

!BitizenDetailController methodsFor: 'accessing' stamp: 'HwaJong 3/14/2014 14:49'!
selectedBititzenMorph
	^ selectedBititzenMorph! !

!BitizenDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/20/2014 14:05'!
setOrClearHomeOfSelectedBitizen
	|b|
	b := self model.
	b hasHome
		ifTrue: 
			[b beHomeless.
			ownerController ownerController floorListController refreshSelectionAndDetail]
		ifFalse: 
			[|cb|
			cb := ChooseFromBuilder new.
			cb title: 'select resident floor'.
			ownerController ownerController model residentalFloorsNeedingBitizen do:
				[:each|
				cb choiceString: 'floor ', each number printString value: [ each addBitizen: b]].
			cb chooseFromValuesTitle].
	self refreshFromRootController! !

!BitizenDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/20/2014 14:05'!
setOrClearJobOfSelectedBitizen
	|b|
	b := self model.
	b hasJob
		ifTrue: 
			[b beJobless.
			ownerController ownerController floorListController refreshSelectionAndDetail]
		ifFalse: 
			[|cb|
			cb := ChooseFromBuilder new.
			cb title: 'select job'.
			ownerController ownerController model commercialFloorsNeedingBitizen do:
				[:each|
				cb choiceString: each job jobName value: [ each addBitizen: b ]].
			cb chooseFromValuesTitle].
	self refreshFromRootController! !

!BitizenDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/14/2014 14:50'!
showHomeFloorOfSelectedBitizen
	self showSelectedBitizenWithFloorGetter: #homeFloor! !

!BitizenDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/14/2014 14:55'!
showJobFloorOfSelectedBitizen
	self showSelectedBitizenWithFloorGetter: #jobFloor! !

!BitizenDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/19/2014 21:21'!
showSelectedBitizenWithFloorGetter: aSymbol

	ownerController ownerController selectMainTabNamed: 'floor'.
	ownerController ownerController floorListController refreshListAndSelect: (self model perform: aSymbol).
	
	ownerController ownerController floorListController detailController selectItem: self model.! !

!BitizenDetailController methodsFor: 'updating widgets' stamp: 'HwaJong 3/27/2014 15:51'!
updateWithModel

	self ownersListModel
		ifHasSelection: 
			[:sel|
			self selectedBititzenMorph model: sel.
			self changed: #hasModel.
			self changed: #jobFloorString.
			self changed: #homeFloorString.]
	! !

GGDetailController subclass: #JobDetailController
	instanceVariableNames: 'jobTypeDropListModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!JobDetailController methodsFor: 'testing' stamp: 'HwaJong 3/18/2014 12:09'!
canPresent: aTTJob 
	^aTTJob isKindOf: TTJob! !

!JobDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/19/2014 21:13'!
jobColor
	^self ownersListModel
		ifHasSelection: [:job| job jobColor ] 
		ifDoesNotHaveSelection: [ Color transparent ]! !

!JobDetailController methodsFor: 'accessing' stamp: 'HwaJong 3/19/2014 21:19'!
jobName
	^self ownersListModel
		ifHasSelection: [:sel| sel jobName ]
		ifDoesNotHaveSelection: [ '???' ]! !

!JobDetailController methodsFor: 'accessing' stamp: 'HwaJong 3/19/2014 21:19'!
jobName: aString
	self ownersListModel
		ifHasSelection: [:sel| sel jobName: aString. self refreshFromRootController ]
		ifDoesNotHaveSelection: [ ]! !

!JobDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/18/2014 12:08'!
jobTypeDropList
	^self jobTypeDropListModel list collect: #typeName! !

!JobDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/19/2014 21:19'!
jobTypeDropListIndex
	^self ownersListModel
		ifHasSelection: [:sel| self jobTypeDropListModel list indexOf: sel class ]
		ifDoesNotHaveSelection: [ 0 ]! !

!JobDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/19/2014 21:00'!
jobTypeDropListIndex: anInteger 
	|newTypeClass|
	self jobTypeDropListModel selectionIndex: anInteger.	 
	newTypeClass := self jobTypeDropListModel selection.
	self model becomeOfJobClass: newTypeClass.
	self refreshFromRootController! !

!JobDetailController methodsFor: 'accessing' stamp: 'HwaJong 3/18/2014 12:06'!
jobTypeDropListModel
	^jobTypeDropListModel setDefault: #jobTypeDropListModelDefault for: self withSetter: #jobTypeDropListModel:.! !

!JobDetailController methodsFor: 'accessing' stamp: 'HwaJong 3/18/2014 12:08'!
jobTypeDropListModel: aTGListModel 
	jobTypeDropListModel := aTGListModel! !

!JobDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/18/2014 12:08'!
jobTypeDropListModelDefault
	^TGListModel new list: TinyTowerGame jobClasses! !

!JobDetailController methodsFor: 'accessing' stamp: 'HwaJong 3/20/2014 14:13'!
morph
	|q|
	q := QuickPrototyping for: self.
	^q column: 
		{q text: #jobName.
		q dropList: #jobType.
		q staticColor: #jobColor}! !

!JobDetailController methodsFor: 'updating widgets' stamp: 'HwaJong 3/19/2014 21:13'!
updateWithModel
	self changed: #jobName.
	self changed: #jobTypeDropListIndex.
	self changed: #jobColor.! !

GGDetailController subclass: #LoungeDetailController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!LoungeDetailController methodsFor: 'testing' stamp: 'HwaJong 3/25/2014 00:06'!
canPresent: aFloor
	^aFloor isKindOf: LoungeFloor! !

!LoungeDetailController methodsFor: 'morph' stamp: 'HwaJong 3/25/2014 00:05'!
morph
	^'Lounge' asMorph! !

!LoungeDetailController methodsFor: 'updating widgets' stamp: 'HwaJong 3/25/2014 00:06'!
updateWithModel
	! !

GGDetailController subclass: #MissionDetailController
	instanceVariableNames: 'requiredJobListController'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!MissionDetailController methodsFor: 'testing' stamp: 'HwaJong 3/18/2014 11:24'!
canPresent: aTTMission 
	^aTTMission isKindOf: TTMission! !

!MissionDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/19/2014 21:22'!
missionCanBeDone
	^ownerController itemIsSelected and: [ self model canBeDone ]! !

!MissionDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/19/2014 21:20'!
missionName
	^self ownersListModel
		ifHasSelection: [:m| m name ]
		ifDoesNotHaveSelection:  [ '----' ]! !

!MissionDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/19/2014 21:20'!
missionName: aString
	self ownersListModel
		ifHasSelection: 
			[:m| m name: aString.
			self changed: #missionName.
			ownerController refreshElements]! !

!MissionDetailController methodsFor: 'accessing' stamp: 'HwaJong 3/21/2014 13:22'!
morph
	|q|
	q := QuickPrototyping for: self.
	^q column: 
		{q title: 'orinal number' text: #ordinalNumberString width: 80.
		q title: 'name' text: #missionName.
		q checkbox: 'done' accessor: #selectedMissionIsDone enabled: #missionCanBeDone.
		self requiredJobListController morph} ! !

!MissionDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/19/2014 21:20'!
ordinalNumberString
	^self ownersListModel
		ifHasSelection: [:mission| mission ordinalNumber printString ] 
		ifDoesNotHaveSelection: [ '--' ]! !

!MissionDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/19/2014 21:20'!
ordinalNumberString: aString
	self ownersListModel
		ifHasSelection: 
			[:mission| mission ordinalNumber: aString asNumber.
			self changed: #ordinalNumberString.
			ownerController refreshElements ] ! !

!MissionDetailController methodsFor: 'accessing' stamp: 'HwaJong 3/18/2014 19:56'!
requiredJobListController
	^requiredJobListController setDefault: #requiredJobListControllerDefault for: self withSetter: #requiredJobListController:! !

!MissionDetailController methodsFor: 'accessing' stamp: 'HwaJong 3/18/2014 19:56'!
requiredJobListController: aMissionDotRequiredJobListController 
	requiredJobListController := aMissionDotRequiredJobListController! !

!MissionDetailController methodsFor: 'defaults' stamp: 'HwaJong 3/18/2014 19:56'!
requiredJobListControllerDefault
	^MissionDotRequiredJobListController newWithOwnerController: self! !

!MissionDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/19/2014 21:20'!
selectedMissionIsDone
	^self ownersListModel 
		ifHasSelection: [:selection | selection isDone ] 
		ifDoesNotHaveSelection: [ false ]! !

!MissionDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/27/2014 15:36'!
selectedMissionIsDone: aBoolean 
	self model isDone: aBoolean.
	ownerController refreshElements.
	ownerController changed: #summaryString! !

!MissionDetailController methodsFor: 'updating widgets' stamp: 'HwaJong 3/18/2014 20:35'!
updateWithModel

	self changed: #missionCanBeDone.
	self changed: #selectedMissionIsDone.
	self changed: #missionName.
	self changed: #ordinalNumberString.
	
	self requiredJobListController refresh! !

GGDetailController subclass: #MissionIssueDetailController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!MissionIssueDetailController methodsFor: 'testing' stamp: 'HwaJong 3/19/2014 20:20'!
canPresent: aTTAction 
	^aTTAction isKindOf: TTDoMissionAction! !

!MissionIssueDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/19/2014 21:01'!
doMission
	self model mission isDone: true.
	self refreshFromRootController! !

!MissionIssueDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/19/2014 20:29'!
goPageSelectMission
	|aTinyTowerGameController aMission|
	aTinyTowerGameController := ownerController ownerController.
	aMission := self model mission.
	aTinyTowerGameController showMission: aMission! !

!MissionIssueDetailController methodsFor: 'accessing' stamp: 'HwaJong 3/19/2014 20:19'!
morph
	|q|
	q := QuickPrototyping for: self.
	^q column: 
		{q button: 'show mission' action: #goPageSelectMission.
		q button: 'make mission done' action: #doMission.}! !

!MissionIssueDetailController methodsFor: 'updating widgets' stamp: 'HwaJong 3/19/2014 20:23'!
updateWithModel
	! !

GGDetailController subclass: #ReplaceBitizenIssueDetailController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!ReplaceBitizenIssueDetailController methodsFor: 'testing' stamp: 'HwaJong 3/19/2014 23:40'!
canPresent: aTTAction 
	^aTTAction isKindOf: TTReplaceEmployedBitizenAction! !

!ReplaceBitizenIssueDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/19/2014 23:53'!
doReplacement
	self model doReplacement.
	self refreshFromRootController! !

!ReplaceBitizenIssueDetailController methodsFor: 'testing' stamp: 'HwaJong 3/19/2014 23:42'!
issueExplanation
	^self ownersListModel 
		ifHasSelection: [:issue| issue printString ] 
		ifDoesNotHaveSelection: [ '?' ]! !

!ReplaceBitizenIssueDetailController methodsFor: 'testing' stamp: 'HwaJong 3/19/2014 23:52'!
issueExplanationLine1
	^self ownersListModel 
		ifHasSelection: [:issue| 'unemployed bitizen ', issue replacingBitizen bitName ] 
		ifDoesNotHaveSelection: [ '' ]! !

!ReplaceBitizenIssueDetailController methodsFor: 'testing' stamp: 'HwaJong 3/19/2014 23:57'!
issueExplanationLine2
	^self ownersListModel 
		ifHasSelection: [:issue| 'can work better in ', issue replacedBitizen job jobName, ' (', issue replacedBitizen jobFloor number printString, ')' ] 
		ifDoesNotHaveSelection: [ '' ]! !

!ReplaceBitizenIssueDetailController methodsFor: 'testing' stamp: 'HwaJong 3/23/2014 09:52'!
issueExplanationLine3
	^self ownersListModel 
		ifHasSelection: [:issue| 'than ', issue replacedBitizen bitName, ' who works there.' ] 
		ifDoesNotHaveSelection: [ '' ]! !

!ReplaceBitizenIssueDetailController methodsFor: 'morph' stamp: 'HwaJong 3/19/2014 23:47'!
morph
	|q|
	q := QuickPrototyping for: self.
	^q column: 
		{q label: #issueExplanationLine1.
		q label: #issueExplanationLine2.
		q label: #issueExplanationLine3.
		q button: 'make a replacement' action: #doReplacement.}! !

!ReplaceBitizenIssueDetailController methodsFor: 'updating widgets' stamp: 'HwaJong 3/19/2014 23:51'!
updateWithModel
	self changed: #issueExplanationLine1.
	self changed: #issueExplanationLine2.
	self changed: #issueExplanationLine3.! !

GGDetailController subclass: #ShowBitizenIssueDetailController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!ShowBitizenIssueDetailController commentStamp: '' prior: 0!
A MissionDetailController is xxxxxxxxx.

Instance Variables
	listController:		<Object>
	requiredJobListModel:		<Object>

listController
	- xxxxx

requiredJobListModel
	- xxxxx
!

!ShowBitizenIssueDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/20/2014 13:16'!
canPresent: aTTAction 
	^(aTTAction isKindOf: TTShowBitizenAction) or: [aTTAction isKindOf: TTCanGetDreamJobAction ]! !

!ShowBitizenIssueDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/29/2014 09:34'!
detailControllerPriority
	^5999! !

!ShowBitizenIssueDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/19/2014 11:22'!
goPageSelectBitizen
	|aTinyTowerGameController aBitizen|
	aTinyTowerGameController := ownerController ownerController.
	aBitizen := self model bitizen.
	aTinyTowerGameController showBitizen: aBitizen! !

!ShowBitizenIssueDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/19/2014 11:22'!
morph
	|q|
	q := QuickPrototyping for: self.
	^q button: 'show bitizen' action: #goPageSelectBitizen enabled: #selectedIssueCanBeResolved! !

!ShowBitizenIssueDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/17/2014 09:36'!
selectedIssueCanBeResolved
	^ownerController itemIsSelected and: [ self model canBeResolved ]! !

!ShowBitizenIssueDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/16/2014 22:38'!
updateWithModel
	self changed: #selectedIssueCanBeResolved! !

GGDetailController subclass: #ShowFloorIssueDetailController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!ShowFloorIssueDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/19/2014 11:56'!
canPresent: aTTAction 
	^aTTAction isKindOf: TTFloorNeedsBitizenAction! !

!ShowFloorIssueDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/19/2014 12:03'!
goPageSelectFloor
	|aTinyTowerGameController aFloor|
	aTinyTowerGameController := ownerController ownerController.
	aFloor := self model floor.
	aTinyTowerGameController showFloor: aFloor! !

!ShowFloorIssueDetailController methodsFor: 'as yet unclassified ' stamp: 'HwaJong 3/19/2014 11:53'!
morph
	|q|
	q := QuickPrototyping for: self.
	^q button: 'show floor' action: #goPageSelectFloor enabled: #selectedIssueCanBeResolved! !

!ShowFloorIssueDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/19/2014 21:20'!
selectedIssueCanBeResolved
	^self ownersListModel
		ifHasSelection: [:issue| true ] 
		ifDoesNotHaveSelection: [ false ]! !

!ShowFloorIssueDetailController methodsFor: 'updating widgets' stamp: 'HwaJong 3/19/2014 11:58'!
updateWithModel
	self changed: #selectedIssueCanBeResolved! !

GGDetailController subclass: #TTCanGetDreamJobActionDetailController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!TTCanGetDreamJobActionDetailController commentStamp: '' prior: 0!
A MissionDetailController is xxxxxxxxx.

Instance Variables
	listController:		<Object>
	requiredJobListModel:		<Object>

listController
	- xxxxx

requiredJobListModel
	- xxxxx
!

!TTCanGetDreamJobActionDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/29/2014 09:34'!
canPresent: aTTAction 
	^(aTTAction isKindOf: TTShowBitizenAction) or: [aTTAction isKindOf: TTCanGetDreamJobAction ]! !

!TTCanGetDreamJobActionDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/2/2014 02:56'!
getDreamJob
	self model getDreamJob.
	self refreshFromRootController! !

!TTCanGetDreamJobActionDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/29/2014 09:34'!
goPageSelectBitizen
	|aTinyTowerGameController aBitizen|
	aTinyTowerGameController := ownerController ownerController.
	aBitizen := self model bitizen.
	aTinyTowerGameController showBitizen: aBitizen! !

!TTCanGetDreamJobActionDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/29/2014 10:20'!
issueExplanationLine1
	^[self model bitizen bitName, ' can get'] on: SubscriptOutOfBounds do: [ :exp| 'got error' ]! !

!TTCanGetDreamJobActionDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/29/2014 10:21'!
issueExplanationLine2
	^['dream job at ' , self model dreamJobFloor longerSummaryString] on: SubscriptOutOfBounds do: [ :exp| 'got error' ]! !

!TTCanGetDreamJobActionDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/3/2014 15:58'!
issueExplanationLine3
	^[self model needsToUnemploySomeone 
		ifTrue: ['replacing ', self model worstEmployeeOfDreamJobFloor bitName]
		ifFalse: [''] ] on: SubscriptOutOfBounds do: [ :exp| 'got error' ]! !

!TTCanGetDreamJobActionDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/2/2014 02:57'!
morph
	|q|
	q := QuickPrototyping for: self.
	^q column: 
		{q button: 'show bitizen' action: #goPageSelectBitizen enabled: #selectedIssueCanBeResolved.
		q column: {q label: #issueExplanationLine1.
		q label: #issueExplanationLine2.
		q label: #issueExplanationLine3.
		q button: 'get dream job' action: #getDreamJob enabled: #selectedIssueCanBeResolved.}.
		}! !

!TTCanGetDreamJobActionDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/29/2014 09:34'!
selectedIssueCanBeResolved
	^ownerController itemIsSelected and: [ self model canBeResolved ]! !

!TTCanGetDreamJobActionDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/29/2014 09:57'!
updateWithModel
	self changed: #selectedIssueCanBeResolved.
	self changed: #issueExplanationLine1.
	self changed: #issueExplanationLine2.
	self changed: #issueExplanationLine3.! !

GGDetailController subclass: #TTEvictBitizenActionDetailController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!TTEvictBitizenActionDetailController methodsFor: 'testing' stamp: 'HwaJong 3/20/2014 13:12'!
canPresent: aTTAction 
	^aTTAction isKindOf: TTEvictBitizenAction! !

!TTEvictBitizenActionDetailController methodsFor: 'actions' stamp: 'HwaJong 3/20/2014 13:29'!
evictBitizen
	self model bitizen removeFromGame.
	self refreshFromRootController! !

!TTEvictBitizenActionDetailController methodsFor: 'actions' stamp: 'HwaJong 3/20/2014 13:13'!
goPageSelectBitizen
	|aTinyTowerGameController aBitizen|
	aTinyTowerGameController := ownerController ownerController.
	aBitizen := self model bitizen.
	aTinyTowerGameController showBitizen: aBitizen! !

!TTEvictBitizenActionDetailController methodsFor: 'morph' stamp: 'HwaJong 3/28/2014 22:06'!
morph
	|q|
	q := QuickPrototyping for: self.
	^q column: 
		{q label: #whereBitizenIsString.
		q button: 'show bitizen' action: #goPageSelectBitizen.
		q button: 'evict!!' action: #evictBitizen.}! !

!TTEvictBitizenActionDetailController methodsFor: 'updating widgets' stamp: 'HwaJong 3/28/2014 22:06'!
updateWithModel
	self changed: #whereBitizenIsString! !

!TTEvictBitizenActionDetailController methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/3/2014 18:24'!
whereBitizenIsString
	^self ownerController listModel
		ifHasSelection: [:issue| 
			issue bitizen homeFloor
				ifNil: ['no home']
				ifNotNil: ['home ', issue bitizen homeFloor number printString]]
		ifDoesNotHaveSelection: [ '---' ]! !

GGDetailController subclass: #TTNotFunctioningStringActionDetailController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!TTNotFunctioningStringActionDetailController methodsFor: 'testing' stamp: 'HwaJong 3/20/2014 00:26'!
canPresent: aTTAction 
	^aTTAction isKindOf: TTNotFunctioningStringAction! !

!TTNotFunctioningStringActionDetailController methodsFor: 'accessing' stamp: 'HwaJong 3/20/2014 14:07'!
morph
	|q|
	q := QuickPrototyping for: self.
	^q staticLabel: 'There is nothing I can do about.'! !

!TTNotFunctioningStringActionDetailController methodsFor: 'updating widgets' stamp: 'HwaJong 3/20/2014 00:27'!
updateWithModel
! !

Object subclass: #BitizenCollection
	instanceVariableNames: 'bitizens'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!BitizenCollection methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 11:35'!
abilitySumWithGetter: aSymbol
	^self bitizens inject: 0 into: [ :sum :each| sum + (each perform: aSymbol) ]! !

!BitizenCollection methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 12:07'!
abilitySums
	^"Dictionary newFrom: "
		{#food -> self foodAbilitySum.
		#service -> self serviceAbilitySum.
		#recreation -> self recreationAbilitySum.
		#retail -> self retailAbilitySum.
		#creative -> self creativeAbilitySum }! !

!BitizenCollection methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 12:12'!
abilityTypeNameOfBestAbilitySum
	|as winner|
	as := self abilitySums.
	winner := (as asSortedCollection: (UnarySortDescriptor ascendingBy: #value)) last.
	^winner key! !

!BitizenCollection methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/31/2014 19:40'!
abilityTypeNameOfMostDreamJob
	^self sortedCountsOfDreamJobTypeName first value! !

!BitizenCollection methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 11:22'!
addBitizen: aBitizen 
	self bitizens add: aBitizen! !

!BitizenCollection methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 11:22'!
bitizens
	^bitizens setDefault: #bitizensDefault for: self withSetter: #bitizens:! !

!BitizenCollection methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 11:23'!
bitizens: aCollection 
	bitizens := aCollection! !

!BitizenCollection methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 11:23'!
bitizensDefault
	^Bag new! !

!BitizenCollection methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 11:38'!
creativeAbilitySum
	^self abilitySumWithGetter: #creativeAbility! !

!BitizenCollection methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 12:19'!
dreamJobCounts
	self bitizens collect: [:each| each dreamJob class typeName]! !

!BitizenCollection methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 11:35'!
foodAbilitySum
	^self abilitySumWithGetter: #foodAbility! !

!BitizenCollection methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 11:35'!
recreationAbilitySum
	^self abilitySumWithGetter: #recreationAbility! !

!BitizenCollection methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 11:37'!
retailAbilitySum
	^self abilitySumWithGetter: #retailAbility! !

!BitizenCollection methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/28/2014 11:35'!
serviceAbilitySum
	^self abilitySumWithGetter: #serviceAbility! !

!BitizenCollection methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/31/2014 19:40'!
sortedCountsOfDreamJobTypeName
	^(self bitizens asBag collect: [:each| each dreamJob class typeName]) sortedCounts! !

Object subclass: #ObjectManagedByTinyTowerGame
	instanceVariableNames: 'game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

ObjectManagedByTinyTowerGame subclass: #Bitizen
	uses: ChangeAnnouncingClassCheckingHashProofTrait
	instanceVariableNames: 'bitName foodAbility serviceAbility recreationAbility retailAbility creativeAbility homeFloor jobFloor dreamJob'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

Bitizen class
	uses: ChangeAnnouncingClassCheckingHashProofTrait classTrait
	instanceVariableNames: ''!

!Bitizen class methodsFor: 'instance creation' stamp: 'HwaJong 12/10/2012 13:33'!
bitName: aByteString dreamJobName: aByteString2 food: aSmallInteger service: aSmallInteger4 recreation: aSmallInteger5 retail: aSmallInteger6 creative: aSmallInteger7 
	^self new
		bitName: aByteString;
		foodAbility: aSmallInteger;
		serviceAbility: aSmallInteger4;
		recreationAbility: aSmallInteger5;
		retailAbility: aSmallInteger6;
		creativeAbility: aSmallInteger7;
		dreamJobName: aByteString2! !

!Bitizen methodsFor: 'testing' stamp: 'HwaJong 3/10/2014 12:55'!
abilityArray
	^{self foodAbility. self serviceAbility. self recreationAbility. self retailAbility. self creativeAbility}! !

!Bitizen methodsFor: 'testing' stamp: 'HwaJong 3/10/2014 12:35'!
abilityOfDreamJob
	^self dreamJob meaningfulAbilityOfBitizen: self! !

!Bitizen methodsFor: 'testing' stamp: 'HwaJong 3/3/2014 00:28'!
abilityOfEmployedJob
	^self job meaningfulAbilityOfBitizen: self! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/20/2014 13:55'!
beHomeless
	self homeFloor removeBitizen: self ! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/23/2014 22:23'!
beJobless
	jobFloor
		ifNotNil:  
			[jobFloor removeBitizen: self.
			self jobFloor: nil]! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:14'!
bitName
	^ bitName! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 3/29/2014 23:49'!
bitName: aString
	bitName := aString asUppercase.
	self announceHashHasChanged.
	self game beDirty.! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/2/2014 01:46'!
checkUsingJob: aTTJob 
	(self referencesJob: aTTJob)
		ifTrue: [ TTJobInUse new job: aTTJob; signal ]! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/29/2014 10:07'!
commercialFloorOfDreamJob
	^self game commercialFloorOfJob: self dreamJob! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:14'!
creativeAbility
	^ creativeAbility! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 4/2/2014 15:28'!
creativeAbility: anInteger
	creativeAbility := anInteger.
	self announceHashHasChanged.
	self game beDirty.! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 2/23/2014 23:44'!
dreamJob
	^ dreamJob! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 4/2/2014 15:28'!
dreamJob: aTTJob
	dreamJob := aTTJob.
	self announceHashHasChanged.
	self game beDirty.! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/23/2014 09:59'!
emoticon
	^{':|'. ':)'. ':('} at: self happiness! !

!Bitizen methodsFor: 'testing' stamp: 'HwaJong 3/10/2014 13:00'!
employedToNotToUseBestAbility
	^self hasJob and: [self abilityOfEmployedJob < self abilityArray asSortedCollection last]! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/23/2014 10:03'!
employmentString
	^self job
		ifNil: [ 'UNEMPLOYED' ] 
		ifNotNil: [:job| job jobName ]! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:14'!
foodAbility
	^ foodAbility! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 4/2/2014 15:28'!
foodAbility: anInteger
	foodAbility := anInteger.
	self announceHashHasChanged.
	self game beDirty.! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 3/29/2014 23:51'!
gameDefault
	^TinyTowerGameDummy new! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/30/2014 00:33'!
getJobNamed: aString 
	self jobFloor: (self game floorJobNamed: aString).! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/2/2014 15:27'!
gettersForEquality
	^#(bitName foodAbility serviceAbility recreationAbility retailAbility creativeAbility homeFloor jobFloor dreamJob)! !

!Bitizen methodsFor: 'testing' stamp: 'HwaJong 3/11/2014 15:40'!
gotDreamJob
	^self hasJob and: [jobFloor job == dreamJob]! !

!Bitizen methodsFor: 'strings' stamp: 'HwaJong 3/6/2014 16:18'!
gotDreamJobString

	^self gotDreamJob ifTrue: ['D'] ifFalse: [' '].! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/6/2014 16:16'!
happiness
	jobFloor isNil ifTrue: [ ^1 ].
	^self gotDreamJob
		ifTrue: [ 3 ]
		ifFalse: 
			[ self abilityOfEmployedJob < 5
				ifTrue: [1]
				ifFalse: [2] ]! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/23/2014 00:12'!
hasHome
	^homeFloor notNil ! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 15:58'!
hasJob
	^jobFloor notNil ! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:23'!
homeFloor
	^ homeFloor! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 4/2/2014 15:28'!
homeFloor: aFloor
	homeFloor := aFloor.
	self announceHashHasChanged.
	self game beDirty.
! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/24/2014 01:16'!
homeFloorNumber
	^homeFloor
		ifNil: [ -1 ] ifNotNil: [ homeFloor number ]! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/22/2014 22:07'!
isEmployeed
	^jobFloor notNil ! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/30/2014 00:33'!
isHealthy
	^self gameIsDummy
		ifTrue: [ true ]
		ifFalse: [ 
			{[self game bitizens identityIncludes: self].
			[ homeFloor isHealthy ].
			[ jobFloor isHealthy ].
			[ dreamJob isHealthy ]} allSatisfied ]! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/26/2014 17:35'!
job
	^jobFloor
		ifNil: [ nil ] ifNotNil: [ jobFloor job ]! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:23'!
jobFloor
	^ jobFloor! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 4/2/2014 15:28'!
jobFloor: aFloor
	jobFloor := aFloor.
	self announceHashHasChanged.
	self game beDirty.! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 22:09'!
printOn: stream

	super printOn: stream.
	stream nextPut: $(.
	stream nextPutAll: bitName.
	stream nextPut: $).! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:14'!
recreationAbility
	^ recreationAbility! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 4/2/2014 15:28'!
recreationAbility: anInteger
	recreationAbility := anInteger.
	self announceHashHasChanged.
	self game beDirty.! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/3/2014 00:25'!
referencesFloor: aFloor 
	^homeFloor == aFloor or: [ jobFloor == aFloor ]! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/2/2014 01:18'!
referencesJob: aTTJob 
	^dreamJob == aTTJob or: [ self job == aTTJob ]! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/30/2014 00:33'!
removeFromGame
	self game removeBitizen: self! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:14'!
retailAbility
	^ retailAbility! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 4/2/2014 15:28'!
retailAbility: anInteger
	retailAbility := anInteger.
	self announceHashHasChanged.
	self game beDirty.! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:14'!
serviceAbility
	^ serviceAbility! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 4/2/2014 15:28'!
serviceAbility: anInteger
	serviceAbility := anInteger.
	self announceHashHasChanged.
	self game beDirty.! !

ObjectManagedByTinyTowerGame subclass: #Floor
	uses: ClassCheckingHashProofTrait
	instanceVariableNames: 'number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

Floor class
	uses: ClassCheckingHashProofTrait classTrait
	instanceVariableNames: ''!

Floor subclass: #BitizenedFloor
	instanceVariableNames: 'bitizenOrderedCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!BitizenedFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 23:46'!
bitizenCount
	^self bitizenOrderedCollection count: #notNil! !

!BitizenedFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/2/2014 15:44'!
bitizenNames
	^self bitizenOrderedCollection collect: #bitName ! !

!BitizenedFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 20:36'!
bitizenOrderedCollection
	^bitizenOrderedCollection setDefault: #bitizenOrderedCollectionDefault for: self withSetter: #bitizenOrderedCollection:! !

!BitizenedFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 20:37'!
bitizenOrderedCollection: anOrderedCollection
	bitizenOrderedCollection := anOrderedCollection! !

!BitizenedFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/30/2014 00:33'!
bitizenOrderedCollectionDefault
	^self gameIsDummy
		ifTrue: [OrderedCollection new]
		ifFalse: [ (self game bitizens select: [ :each| each referencesFloor: self ]) asOrderedCollection ]! !

!BitizenedFloor methodsFor: 'accessing' stamp: 'HwaJong 3/14/2014 12:31'!
bitizens
	^self bitizenOrderedCollection asSet! !

!BitizenedFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/28/2014 20:50'!
isBitizenful
	^self bitizenCount >= self maxPopulation! !

!BitizenedFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/17/2014 09:22'!
moveDownBitizen: aBitizen 
	| bitIndex |	
	bitIndex := self bitizenOrderedCollection indexOf: aBitizen.
	bitIndex = self bitizenOrderedCollection size ifTrue: [^self].
	self bitizenOrderedCollection swap: bitIndex with: bitIndex+1.! !

!BitizenedFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/17/2014 09:20'!
moveUpBitizen: aBitizen 
	| bitIndex |	
	bitIndex := self bitizenOrderedCollection indexOf: aBitizen.
	bitIndex = 1 ifTrue: [^self].
	self bitizenOrderedCollection swap: bitIndex-1 with: bitIndex.
! !

BitizenedFloor subclass: #CommercialFloor
	instanceVariableNames: 'job'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!CommercialFloor class methodsFor: 'instance creation' stamp: 'HwaJong 12/10/2012 17:21'!
number: aSmallInteger job: aJob 
	^self new
		number: aSmallInteger;
		job: aJob! !

!CommercialFloor methodsFor: 'bitizen' stamp: 'HwaJong 3/30/2014 01:22'!
addBitizen: aBitizen 

	(self bitizenOrderedCollection includes: aBitizen)
		ifFalse: 
			[self bitizenOrderedCollection add: aBitizen.
			aBitizen jobFloor: self]! !

!CommercialFloor methodsFor: 'job' stamp: 'HwaJong 3/2/2014 01:46'!
checkUsingJob: aTTJob 
	(self referencesJob: aTTJob)
		ifTrue: [ TTJobInUse new job: aTTJob; signal ]! !

!CommercialFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/20/2014 13:38'!
descriptionStringForFloorNeedsBitizenAction
	^self jobName
! !

!CommercialFloor methodsFor: 'bitizen' stamp: 'HwaJong 2/16/2014 11:00'!
employBitizen: aBitizen 
	self bitizens add: aBitizen.
	aBitizen jobFloor: self.! !

!CommercialFloor methodsFor: 'literal interface' stamp: 'HwaJong 3/30/2014 00:33'!
employBitizenNamed: aString 
	self employBitizen: (self game bitizenNamed: aString)! !

!CommercialFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/2/2014 15:44'!
gettersForEquality
	^#(number job bitizenNames)! !

!CommercialFloor methodsFor: 'job' stamp: 'HwaJong 12/10/2012 17:49'!
hasJobNamed: aByteString 
	^job jobName = aByteString ! !

!CommercialFloor methodsFor: 'testing' stamp: 'HwaJong 12/10/2012 01:30'!
isCommercialFloor
	^true! !

!CommercialFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/30/2014 00:33'!
isHealthy
	^self gameIsDummy
		ifTrue: [ true ] 
		ifFalse: [ (self game floors identityIncludes: self) and: [ self bitizenOrderedCollection allSatisfy: [ :each| each game == self game ] ] ]! !

!CommercialFloor methodsFor: 'job' stamp: 'HwaJong 12/10/2012 01:32'!
job
	^ job! !

!CommercialFloor methodsFor: 'job' stamp: 'HwaJong 12/10/2012 01:32'!
job: aString
	job := aString
! !

!CommercialFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/15/2014 15:11'!
jobName
	^self job jobName! !

!CommercialFloor methodsFor: 'string' stamp: 'HwaJong 3/2/2014 13:36'!
longerSummaryString
	^job jobName, ' (', number printString, ')'! !

!CommercialFloor methodsFor: 'bitizen' stamp: 'HwaJong 12/10/2012 01:14'!
maxPopulation
	^3! !

!CommercialFloor methodsFor: 'printing' stamp: 'HwaJong 3/11/2014 22:30'!
printOn: stream
	super printOn: stream.
	stream nextPut: $(.
	stream print: number.
	stream space.
	stream nextPutAll: job jobName.
	stream nextPut: $).! !

!CommercialFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/25/2014 10:39'!
productionEfficiency
	|discount dr coinCost como maxPro|
	maxPro :=  (200/73).
	self bitizens isEmpty ifTrue: [ ^Float nan ].
	discount := self bitizens sum: [:each| each abilityOfEmployedJob ].
	dr := (100-discount)/100.

	coinCost := self bitizens size * dr.
	como := self bitizens sum: [:each| each gotDreamJob ifTrue: [2] ifFalse: [1] ].

	^(como / coinCost) / maxPro! !

!CommercialFloor methodsFor: 'job' stamp: 'HwaJong 3/2/2014 01:18'!
referencesJob: aTTJob 
	^job == aTTJob! !

!CommercialFloor methodsFor: 'bitizen' stamp: 'HwaJong 3/1/2014 21:20'!
removeBitizen: aBitizen
	(self bitizenOrderedCollection includes: aBitizen)
		ifTrue: 
			[self bitizenOrderedCollection remove: aBitizen.
			aBitizen jobFloor: nil ]! !

!CommercialFloor methodsFor: 'string' stamp: 'HwaJong 3/20/2014 19:38'!
summaryString
	^job jobName, '  (', ('' join: (self bitizenOrderedCollection collect: #gotDreamJobString)), ')'.! !

!CommercialFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/29/2014 10:14'!
worstEmployee
	^(self bitizenOrderedCollection asSortedCollection: 
		(UnarySortDescriptor ascendingBy: [:each| each gotDreamJob ifTrue: [1] ifFalse: [0]] ascendingBy: [:each| self job meaningfulAbilityOfBitizen: each])) first! !

BitizenedFloor subclass: #ResidentFloor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!ResidentFloor class methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/10/2012 17:15'!
number: aSmallInteger 
	^self new number: aSmallInteger! !

!ResidentFloor methodsFor: 'bitizen' stamp: 'HwaJong 3/30/2014 01:22'!
addBitizen: aBitizen 

	(self bitizenOrderedCollection includes: aBitizen)
		ifFalse: 
			[self bitizenOrderedCollection add: aBitizen.
			aBitizen homeFloor: self]
	! !

!ResidentFloor methodsFor: 'job' stamp: 'HwaJong 3/2/2014 01:46'!
checkUsingJob: aTTJob 
	(self referencesJob: aTTJob)
		ifTrue: [ TTJobInUse new job: aTTJob; signal ]! !

!ResidentFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/20/2014 13:39'!
descriptionStringForFloorNeedsBitizenAction
	^'Residental floor'! !

!ResidentFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/2/2014 15:43'!
gettersForEquality
	^#(number bitizenNames)! !

!ResidentFloor methodsFor: 'job' stamp: 'HwaJong 12/10/2012 17:49'!
hasJobNamed: aByteString 
	^false! !

!ResidentFloor methodsFor: 'as yet unclassified ' stamp: 'HwaJong 3/30/2014 00:33'!
isHealthy
	^self gameIsDummy
		ifTrue: [ true ] 
		ifFalse: [ (self game floors identityIncludes: self) and: [ self bitizenOrderedCollection allSatisfy: [ :each| each game == self game ] ] ]! !

!ResidentFloor methodsFor: 'bitizen' stamp: 'HwaJong 12/10/2012 01:14'!
maxPopulation
	^5! !

!ResidentFloor methodsFor: 'bitizen' stamp: 'HwaJong 2/16/2014 11:08'!
moveInBitizen: aBitizen 

	self bitizens add: aBitizen.
	aBitizen homeFloor: self.! !

!ResidentFloor methodsFor: 'bitizen' stamp: 'HwaJong 3/30/2014 00:34'!
moveInBitizenNamed: aString 
	self moveInBitizen: (self game bitizenNamed: aString)! !

!ResidentFloor methodsFor: 'job' stamp: 'HwaJong 3/2/2014 01:15'!
referencesJob: aServiceJob 
	^false! !

!ResidentFloor methodsFor: 'bitizen' stamp: 'HwaJong 3/3/2014 11:55'!
removeBitizen: aBitizen 
	(self bitizenOrderedCollection includes: aBitizen)
		ifTrue: 
			[self bitizenOrderedCollection remove: aBitizen.
			aBitizen homeFloor: nil ]! !

!ResidentFloor methodsFor: 'etc' stamp: 'HwaJong 2/16/2014 00:26'!
removeFromGame
	self game removeFloor: self.! !

!ResidentFloor methodsFor: 'string' stamp: 'HwaJong 3/1/2014 20:39'!
summaryString
	^'Resident  ', (self bitizenOrderedCollection count: [ :each| each notNil ]) printString, '/5'! !

!Floor methodsFor: 'testing' stamp: 'HwaJong 2/25/2014 10:26'!
isCommercialFloor
	^false! !

!Floor methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:12'!
number
	^ number! !

!Floor methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:12'!
number: anInteger
	number := anInteger
! !

Floor subclass: #LoungeFloor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!LoungeFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/2/2014 01:46'!
checkUsingJob: aTTJob 
	(self referencesJob: aTTJob)
		ifTrue: [ TTJobInUse new job: aTTJob; signal ]! !

!LoungeFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/2/2014 15:35'!
gettersForEquality
	^#()! !

!LoungeFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/16/2014 10:03'!
hasJobNamed: aString 
	^false! !

!LoungeFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/20/2014 13:35'!
isBitizenful
	^true! !

!LoungeFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/30/2014 00:34'!
isHealthy
	^self gameIsDummy
		ifTrue: [ true ] 
		ifFalse: [ self game floors identityIncludes: self ]! !

!LoungeFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/2/2014 01:15'!
referencesJob: aTTJob 
	^false! !

!LoungeFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/23/2014 23:03'!
summaryString
	^'LOUNGE'! !

!ObjectManagedByTinyTowerGame methodsFor: 'TinyTower' stamp: 'HwaJong 3/30/2014 00:31'!
announcer
	^self gameIsDummy
		ifTrue: [nil]
		ifFalse: [self game announcer]! !

!ObjectManagedByTinyTowerGame methodsFor: 'accessing' stamp: 'HwaJong 3/30/2014 00:27'!
game
	^game setDefault: #gameDefault for: self withSetter: #game:! !

!ObjectManagedByTinyTowerGame methodsFor: 'accessing' stamp: 'HwaJong 2/15/2014 20:16'!
game: aTinyTowerGame
	game := aTinyTowerGame! !

!ObjectManagedByTinyTowerGame methodsFor: 'accessing' stamp: 'HwaJong 3/30/2014 00:27'!
gameDefault
	^TinyTowerGameDummy new! !

!ObjectManagedByTinyTowerGame methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/30/2014 00:29'!
gameIsDummy
	^self game isDummyGame! !

ObjectManagedByTinyTowerGame subclass: #TTJob
	uses: ChangeAnnouncingClassCheckingHashProofTrait
	instanceVariableNames: 'jobName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

TTJob class
	uses: ChangeAnnouncingClassCheckingHashProofTrait classTrait
	instanceVariableNames: ''!

TTJob subclass: #CreativeJob
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!CreativeJob class methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 22:31'!
colorName
	^#crimson! !

!CreativeJob class methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 22:49'!
typeName
	^#creative! !

!CreativeJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2013 14:56'!
color
	^'crimson'! !

!CreativeJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/16/2014 02:23'!
jobColor
	^Color fromHexString: 'FC6A2E'! !

!CreativeJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/3/2014 00:29'!
meaningfulAbilityOfBitizen: aBitizen 
	^aBitizen creativeAbility! !

TTJob subclass: #FoodJob
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!FoodJob class methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 22:31'!
colorName
	^#green! !

!FoodJob class methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 22:49'!
typeName
	^#food! !

!FoodJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2013 15:03'!
color
	^'green'! !

!FoodJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/16/2014 02:26'!
jobColor
	^Color fromHexString: '51D62E'! !

!FoodJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/3/2014 00:30'!
meaningfulAbilityOfBitizen: aBitizen 
	^aBitizen foodAbility! !

TTJob subclass: #RecreationJob
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!RecreationJob class methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 22:47'!
colorName
	^#crimson! !

!RecreationJob class methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 22:49'!
typeName
	^#recreation! !

!RecreationJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2013 14:57'!
color
	^'ivory'! !

!RecreationJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/16/2014 02:25'!
jobColor
	^Color fromHexString: 'EDF895'! !

!RecreationJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/3/2014 00:29'!
meaningfulAbilityOfBitizen: aBitizen 
	^aBitizen recreationAbility! !

TTJob subclass: #RetailJob
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!RetailJob class methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 22:49'!
typeName
	^#retail! !

!RetailJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2013 14:58'!
color
	^'purple'! !

!RetailJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/16/2014 02:24'!
jobColor
	^Color fromHexString: 'E769FD'! !

!RetailJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/3/2014 00:30'!
meaningfulAbilityOfBitizen: aBitizen 
	^aBitizen retailAbility! !

TTJob subclass: #ServiceJob
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!ServiceJob class methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 22:50'!
typeName
	^#service! !

!ServiceJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/10/2012 13:14'!
color
	^'cyan'! !

!ServiceJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/16/2014 02:25'!
jobColor
	^Color fromHexString: '30ADFD'! !

!ServiceJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/3/2014 00:30'!
meaningfulAbilityOfBitizen: aBitizen 
	^aBitizen serviceAbility! !

!TTJob class methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 22:30'!
colorNameIs: aString 
	^self colorName = aString! !

!TTJob class methodsFor: 'instance creation' stamp: 'HwaJong 10/19/2013 14:50'!
crimsonJobName: string2
	^CreativeJob new jobName: string2! !

!TTJob class methodsFor: 'instance creation' stamp: 'HwaJong 10/19/2013 14:51'!
cyanJobName: string2
	^ServiceJob new jobName: string2! !

!TTJob class methodsFor: 'instance creation' stamp: 'HwaJong 10/19/2013 15:03'!
greenJobName: string2
	^FoodJob new jobName: string2! !

!TTJob class methodsFor: 'instance creation' stamp: 'HwaJong 10/19/2013 15:05'!
ivoryJobName: string2
	^RecreationJob new jobName: string2! !

!TTJob class methodsFor: 'instance creation' stamp: 'HwaJong 10/19/2013 15:05'!
jobName: aString
	^self new jobName: aString! !

!TTJob class methodsFor: 'instance creation' stamp: 'HwaJong 10/19/2013 15:05'!
purpleJobName: string2
	^RetailJob new jobName: string2! !

!TTJob class methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 22:30'!
subclassOfColorName: aString 
	^self subclasses detect: [ :each| each colorNameIs: aString ]! !

!TTJob class methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 22:48'!
subclassOfTypeName: aString 
	^self subclasses detect: [ :each| each typeName = aString ]! !

!TTJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/31/2014 21:30'!
becomeOfJobClass: aClass 
	^(aClass new
		game: self game;
		jobName: jobName) become: self! !

!TTJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 22:57'!
gettersForEquality
	^#(jobName)! !

!TTJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/30/2014 00:32'!
isHealthy
	^self gameIsDummy
		ifTrue: [ true ] 
		ifFalse: [ self game jobs identityIncludes: self ]! !

!TTJob methodsFor: 'accessing' stamp: 'HwaJong 10/19/2013 15:05'!
jobName
	^ jobName! !

!TTJob methodsFor: 'accessing' stamp: 'HwaJong 3/31/2014 21:25'!
jobName: aString
	jobName := aString asUppercase.
	self announceHashHasChanged.
	self game beDirty! !

!TTJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 23:08'!
printOn: stream

	stream nextPut: $(.
	stream nextPutAll: self class typeName.
	stream nextPut: $|.
	stream nextPutAll: jobName.
	stream nextPut: $).! !

!TTJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/30/2014 00:34'!
removeFromGame
	self game removeJob: self! !

ObjectManagedByTinyTowerGame subclass: #TTMission
	uses: ClassCheckingHashProofTrait
	instanceVariableNames: 'name ordinalNumber requiredJobs isDone'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

TTMission class
	uses: ClassCheckingHashProofTrait classTrait
	instanceVariableNames: ''!

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/30/2014 18:27'!
addRequiredJob: aTTJob 
	self requiredJobs add: aTTJob.
	self game beDirty.! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/2/2014 13:56'!
availableString
	^self canBeDone
		ifTrue: [ 'can' ]
		ifFalse: [ 'cannot' ]! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/30/2014 00:34'!
canBeDone
	| aj |
	aj := self game jobsInBuilding.
	^self requiredJobs allSatisfy: [ :each| aj includes: each ] ! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/2/2014 01:46'!
checkUsingJob: aTTJob 
	(self referencesJob: aTTJob)
		ifTrue: [ TTJobInUse new job: aTTJob; signal ]! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 17:18'!
doneString
	^self isDone
		ifTrue: [ 'done' ]
		ifFalse: [ 'not done' ]! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/2/2014 15:41'!
gettersForEquality
	^#(ordinalNumber isDone name requiredJobs)! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 17:18'!
isDone
	^isDone setDefault: #isDoneDefault for: self withSetter: #isDone:! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/30/2014 18:29'!
isDone: aBoolean 
	isDone := aBoolean.
	self game beDirty! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 17:18'!
isDoneDefault
	^false! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/30/2014 00:32'!
isHealthy
	^self gameIsDummy
		ifTrue: [ true ] 
		ifFalse: [ 
			{[ self game missions identityIncludes: self ].
			[ self requiredJobs allSatisfy: #isHealthy ]} allSatisfied ]! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 23:59'!
name
	^name setDefault: #nameDefault for: self withSetter: #name:! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/30/2014 18:17'!
name: aString 
	name := aString asUppercase.
	self game beDirty! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/2/2014 00:00'!
nameDefault
	^'no name'! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 01:19'!
ordinalNumber
	^ ordinalNumber! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/30/2014 18:16'!
ordinalNumber: anInteger 
	ordinalNumber := anInteger.
	self game beDirty.! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/2/2014 01:18'!
referencesJob: aTTJob 
	^self requiredJobs identityIncludes: aTTJob! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/30/2014 18:28'!
removeRequiredJob: aTTJob 
	self requiredJobs remove:  aTTJob.
	self game beDirty! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/12/2014 17:22'!
requiredJobNames
	^self requiredJobs collect: #jobName! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 23:58'!
requiredJobs
	^ requiredJobs setDefault: #requiredJobsDefault for: self withSetter: #requiredJobs:! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 01:02'!
requiredJobs: aCollection 
	requiredJobs := aCollection ! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 23:58'!
requiredJobsDefault
	^OrderedCollection new! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 17:30'!
toggleDone
	self isDone: self isDone not! !

Object subclass: #TTAction
	instanceVariableNames: 'game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!TTAction methodsFor: 'as yet unclassified ' stamp: 'HwaJong 3/29/2014 12:56'!
suppressesAction: aTTAction 
	^false! !

TTAction subclass: #TTCanGetDreamJobAction
	instanceVariableNames: 'bitizen worstEmployeeOfDreamJobFloor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!TTCanGetDreamJobAction methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/20/2014 13:16'!
bitizen
	^ bitizen! !

!TTCanGetDreamJobAction methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/10/2014 12:14'!
bitizen: aBitizen 
	bitizen := aBitizen ! !

!TTCanGetDreamJobAction methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/10/2014 12:16'!
canBeResolved
	^true! !

!TTCanGetDreamJobAction methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/29/2014 10:09'!
dreamJobFloor
	^self bitizen commercialFloorOfDreamJob! !

!TTCanGetDreamJobAction methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/2/2014 02:55'!
getDreamJob

	self needsToUnemploySomeone
		ifTrue: 
			[self worstEmployeeOfDreamJobFloor beJobless.
			bitizen commercialFloorOfDreamJob addBitizen: bitizen]
		ifFalse:
			[bitizen commercialFloorOfDreamJob addBitizen: bitizen].! !

!TTCanGetDreamJobAction methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/3/2014 15:58'!
needsToUnemploySomeone
	^(bitizen commercialFloorOfDreamJob bitizenOrderedCollection size) >= 3! !

!TTCanGetDreamJobAction methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/10/2014 12:16'!
printOn: aStream

	aStream nextPutAll: bitizen bitName.
	aStream nextPutAll: ' can get dream job!!!!'! !

!TTCanGetDreamJobAction methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/10/2014 12:19'!
processActionOnTinyTowerGameController: aTinyTowerGameController 
	aTinyTowerGameController selectMainTabNamed: 'bitizen'.
	aTinyTowerGameController selectBitizen: bitizen! !

!TTCanGetDreamJobAction methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/29/2014 12:59'!
suppressesAction: aTTAction 
	^(aTTAction isKindOf: TTReplaceEmployedBitizenAction)
		and: [ aTTAction replacingBitizen = bitizen ]! !

!TTCanGetDreamJobAction methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/29/2014 10:17'!
worstEmployeeOfDreamJobFloor
	^worstEmployeeOfDreamJobFloor setDefault: #worstEmployeeOfDreamJobFloorDefault for: self withSetter: #worstEmployeeOfDreamJobFloor:! !

!TTCanGetDreamJobAction methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/29/2014 10:17'!
worstEmployeeOfDreamJobFloor: aBitizen 
	worstEmployeeOfDreamJobFloor := aBitizen! !

!TTCanGetDreamJobAction methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/29/2014 10:17'!
worstEmployeeOfDreamJobFloorDefault
	^self dreamJobFloor worstEmployee! !

TTAction subclass: #TTDoMissionAction
	instanceVariableNames: 'mission'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!TTDoMissionAction methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/22/2014 12:12'!
canBeResolved
	^true! !

!TTDoMissionAction methodsFor: 'accessing' stamp: 'HwaJong 3/19/2014 20:26'!
mission
	^ mission! !

!TTDoMissionAction methodsFor: 'accessing' stamp: 'HwaJong 3/19/2014 20:22'!
mission: aTTMission 
	mission := aTTMission ! !

!TTDoMissionAction methodsFor: 'printing' stamp: 'HwaJong 3/19/2014 20:25'!
printOn: aStream

	aStream nextPutAll: 'mission '.
	aStream nextPutAll: mission name.
	aStream nextPutAll: ' can be done.'.! !

TTAction subclass: #TTEvictBitizenAction
	instanceVariableNames: 'bitizen reason'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!TTEvictBitizenAction methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/20/2014 13:13'!
bitizen
	^ bitizen! !

!TTEvictBitizenAction methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/10/2014 12:42'!
bitizen: aBitizen 
	bitizen := aBitizen! !

!TTEvictBitizenAction methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/10/2014 12:42'!
canBeResolved
	^true! !

!TTEvictBitizenAction methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/10/2014 12:44'!
printOn: aStream

	aStream nextPutAll: 'evict '.
	aStream nextPutAll: bitizen bitName.
	aStream nextPutAll: ' ('.
	aStream nextPutAll: reason.
	aStream nextPutAll: ')'.! !

!TTEvictBitizenAction methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/10/2014 12:44'!
processActionOnTinyTowerGameController: aTinyTowerGameController 
	aTinyTowerGameController selectMainTabNamed: 'bitizen'.
	aTinyTowerGameController selectBitizen: bitizen! !

!TTEvictBitizenAction methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/10/2014 12:42'!
reason: aString 
	reason := aString! !

!TTEvictBitizenAction methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/2/2014 02:58'!
suppressesAction: aTTAction 
	^(aTTAction isKindOf: TTCanGetDreamJobAction) and: [ aTTAction bitizen = bitizen ]
! !

TTAction subclass: #TTFloorNeedsBitizenAction
	instanceVariableNames: 'floor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!TTFloorNeedsBitizenAction methodsFor: 'accessing' stamp: 'HwaJong 3/19/2014 12:02'!
floor
	^ floor! !

!TTFloorNeedsBitizenAction methodsFor: 'accessing' stamp: 'HwaJong 3/19/2014 11:58'!
floor: aCommercialFloor 
	floor := aCommercialFloor! !

!TTFloorNeedsBitizenAction methodsFor: 'printing' stamp: 'HwaJong 3/20/2014 13:38'!
printOn: aStream

	aStream nextPutAll: 'floor '.
	aStream print: floor number.
	aStream space.
	aStream nextPutAll: floor descriptionStringForFloorNeedsBitizenAction.
	aStream nextPutAll: ' needs bitizen'! !

TTAction subclass: #TTNotFunctioningStringAction
	instanceVariableNames: 'string'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!TTNotFunctioningStringAction class methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/10/2014 11:58'!
string: aString
	^self new string: aString! !

!TTNotFunctioningStringAction methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/10/2014 12:10'!
canBeResolved
	^false! !

!TTNotFunctioningStringAction methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/10/2014 12:02'!
printOn: aStream
	aStream nextPutAll: string! !

!TTNotFunctioningStringAction methodsFor: 'accessing' stamp: 'HwaJong 3/10/2014 11:58'!
string
	^string! !

!TTNotFunctioningStringAction methodsFor: 'accessing' stamp: 'HwaJong 3/10/2014 11:59'!
string: aString
	string := aString! !

TTAction subclass: #TTReplaceEmployedBitizenAction
	instanceVariableNames: 'replacedBitizen replacingBitizen'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!TTReplaceEmployedBitizenAction methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/19/2014 23:54'!
doReplacement
	| jobFloor |
	jobFloor := replacedBitizen jobFloor.
	replacedBitizen beJobless.
	jobFloor addBitizen: replacingBitizen ! !

!TTReplaceEmployedBitizenAction methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/19/2014 23:33'!
printOn: aStream
	aStream nextPutAll: 'unemployed '.
	aStream nextPutAll: replacingBitizen bitName.
	aStream nextPutAll: ' can work better in '.
	aStream nextPutAll: replacedBitizen job jobName.
	aStream nextPutAll: ' than '.
	aStream nextPutAll: replacedBitizen bitName.
	aStream nextPutAll: '.'.! !

!TTReplaceEmployedBitizenAction methodsFor: 'accessing' stamp: 'HwaJong 3/19/2014 22:07'!
replacedBitizen
	^ replacedBitizen! !

!TTReplaceEmployedBitizenAction methodsFor: 'accessing' stamp: 'HwaJong 3/19/2014 22:08'!
replacedBitizen: aBitizen
	replacedBitizen := aBitizen! !

!TTReplaceEmployedBitizenAction methodsFor: 'accessing' stamp: 'HwaJong 3/19/2014 22:07'!
replacingBitizen
	^ replacingBitizen! !

!TTReplaceEmployedBitizenAction methodsFor: 'accessing' stamp: 'HwaJong 3/19/2014 22:08'!
replacingBitizen: aBitizen
	replacingBitizen := aBitizen! !

TTAction subclass: #TTShowBitizenAction
	instanceVariableNames: 'bitizen reason verb'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!TTShowBitizenAction commentStamp: '' prior: 0!
A TTEvictBitizenAction is xxxxxxxxx.

Instance Variables
	bitizen:		<Object>
	reason:		<Object>

bitizen
	- xxxxx

reason
	- xxxxx
!

!TTShowBitizenAction methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/19/2014 11:10'!
bitizen
	^ bitizen! !

!TTShowBitizenAction methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/10/2014 13:03'!
bitizen: aBitizen 
	bitizen := aBitizen! !

!TTShowBitizenAction methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/10/2014 13:03'!
canBeResolved
	^true! !

!TTShowBitizenAction methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/19/2014 11:17'!
printOn: aStream

	aStream nextPutAll: verb.
	aStream nextPutAll: ' '.
	aStream nextPutAll: bitizen bitName.
	reason isEmptyOrNil ifFalse: 
		[aStream nextPutAll: ' ('.
		aStream nextPutAll: reason.
		aStream nextPutAll: ')'.]
	! !

!TTShowBitizenAction methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/10/2014 13:03'!
processActionOnTinyTowerGameController: aTinyTowerGameController 
	aTinyTowerGameController selectMainTabNamed: 'bitizen'.
	aTinyTowerGameController selectBitizen: bitizen! !

!TTShowBitizenAction methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/10/2014 13:03'!
reason: aString 
	reason := aString! !

!TTShowBitizenAction methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/10/2014 13:09'!
verb: aString 
	verb := aString ! !

Object subclass: #TTMissionProxy
	instanceVariableNames: 'ordinalNumber name requiredJobNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!TTMissionProxy class methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 00:43'!
ordinalNumber: anInteger name: aString requiredJobNames: aCollection 
	^self new
		ordinalNumber: anInteger;
		name: aString;
		requiredJobNames: aCollection ! !

!TTMissionProxy methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 00:43'!
name: aString 
	name := aString ! !

!TTMissionProxy methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 00:43'!
ordinalNumber: anInteger 
	ordinalNumber := anInteger ! !

!TTMissionProxy methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 00:43'!
requiredJobNames: aCollection 
	requiredJobNames := aCollection ! !

!TTMissionProxy methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/14/2014 13:46'!
valueWithGame: aTinyTowerGame 
	| realObject |
	realObject := TTMission new.
	realObject name: name.
	realObject ordinalNumber: ordinalNumber.
	realObject requiredJobs: (requiredJobNames asOrderedCollection collect: 
		[:each| 
			[aTinyTowerGame jobNamed: each] on: TTNoJobError
			do:
				[:exp| exp addJobAndRetry ] ]).
	^realObject! !

Object subclass: #TinyTowerGame
	uses: ClassCheckingHashProofTrait
	instanceVariableNames: 'floors bitizens jobs announcer missions docLogic'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

TinyTowerGame class
	uses: ClassCheckingHashProofTrait classTrait
	instanceVariableNames: ''!

!TinyTowerGame class methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/30/2014 00:09'!
imageSnapshotDone: aSnapshotDone 
	self allSubInstances do: [ :each| each docLogic hasUnsavedChange: false ] ! !

!TinyTowerGame class methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/30/2014 00:09'!
initialize
	SystemAnnouncer uniqueInstance on: SnapshotDone send: #imageSnapshotDone: to: self.
	Smalltalk addToShutDownList: self. ! !

!TinyTowerGame class methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/18/2014 12:04'!
jobClasses
	^{ FoodJob. ServiceJob. RecreationJob. RetailJob. CreativeJob }! !

!TinyTowerGame class methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/30/2014 00:10'!
shutDown: quitting
	quitting 
		ifTrue: 
			[(self allSubInstances anySatisfy: [:each| each docLogic hasUnsavedChange ]) 
				ifTrue: 
					[(UIManager default confirm: 'Modified TinyTowerGame instance found while quiting image' trueChoice: 'Abort quiting' falseChoice: 'continue Quiting') ifTrue: [Abort signal: 'Press Abandon button']] ].
	^ super shutDown: quitting.! !

!TinyTowerGame class methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/22/2013 16:06'!
workspace1
| tt |
tt := TinyTowerGame new.
tt openBitizenListMorph.
tt openCommercialFloorListMorph.
tt bitizenFromUser.! !

!TinyTowerGame methodsFor: 'job' stamp: 'HwaJong 4/3/2014 16:02'!
addAllKnownJobs
	#( #('JEWELRY STORE' #retail) #('AIRLINE FOOD' #food) #('PHOTO STUDIO' #creative) #('TUTORING CENTER' #service) #('STOCK EXCHANGE' #service) #('ROBOT STORE' #retail) #('VEGAN FOOD' #food) #('MEXICAN FOOD' #food) #('MARTIAL ARTS' #service) #('BAKERY' #food) #('PHARMACY' #service) #('SODA BREWERY' #creative) #('SOFTWARE STUDIO' #creative) #('GLASS STUDIO' #creative) #('CLOCKMAKER' #creative) #('FLORAL STUDIO' #creative) #('BBQ PLACE' #food) #('GRAPHIC DESIGN' #creative) #('ARCHERY RANGE' #recreation) #('PRIVATE EYE' #service) #('HEALTH CLUB' #service) #('FORTUNE TELLER' #service) #('KARAOKE CLUB' #recreation) #('TRAVEL AGENCY' #service) #('FROZEN YOGURT' #food) #('DINER' #food) #('RECORD SHOP' #retail) #('MUSEUM' #recreation) #('GAME STUDIO' #creative) #('HOT DOG JOINT' #food) #('RACQUETBALL' #recreation) #('WEDDING CHAPEL' #service) #('AQUARIUM' #recreation) #('SEAFOOD' #food) #('COMIC STORE' #retail) #('HAT SHOP' #retail) #('AD AGENCY' #creative) #('TEA HOUSE' #food) #('CANDLE SHOP' #retail) #('CAKE STUDIO' #creative) #('SMOOTHIE SHOP' #food) #('AUTO DEALER' #retail) #('LABORATORY' #creative) #('ARCHITECT OFFICE' #creative) #('DONUT SHOP' #food) #('RECYCLING' #service) #('ANIMATION STUDIO' #creative) #('PLANT NURSERY' #retail) #('POTTERY STUDIO' #creative) #('PARK' #recreation) #('BANK' #service) #('BOOK STORE' #retail) #('WOMENS FASHION' #retail) #('SCULPTING STUDIO' #creative) #('PIZZA PLACE' #food) #('TECH STORE' #retail) #('DENTISTS OFFICE' #service) #('TOY STORE' #retail) #('GOLF SIM' #recreation) #('VOLLEYBALL CLUB' #recreation) #('MUSIC STORE' #retail) #('GAME STORE' #retail) #('MENS FASHION' #retail) #('DAY SPA' #service) #('COURTHOUSE' #service) #('SHIP & PRINT' #service) #('PLANETARIUM' #recreation) #('ASIAN CUISINE' #food) #('ROCK CLIMBING' #recreation) #('PET SHOP' #retail) #('BILLIARD HALL' #recreation) #('LAUNDROMAT' #service) #('SUB SHOP' #food) #('CHOCOLATIER' #creative) #('SHOE STORE' #retail) #('CYBER CAFE' #recreation) #('THEATER' #recreation) #('ITALIAN FOOD' #food) #('COSTUME SHOP' #creative) #('FURNITURE STORE' #retail) #('PAINTBALL ARENA' #recreation) #('BIKE SHOP' #retail) #('SUSHI BAR' #food) #('GROCERY STORE' #retail) #('TATTOO PARLOR' #creative) #('COMEDY CLUB' #recreation) #('CASINO' #recreation) #('RECORDING STUDIO' #creative) #('SECURITY OFFICE' #service) #('CINEPLEX' #recreation) #('HAUNTED HOUSE' #recreation) #('OPTOMETRIST' #service) #('COFFEE HOUSE' #food) #('BOWLING ALLEY' #recreation) #('CIRCUS' #recreation) #('WOOD SHOP' #creative) #('FANCY CUISINE' #food) #('PLUMBER' #service) #('DOCTORS OFFICE' #service) #('PUB' #food) #('TV STUDIO' #creative) #('SCOOPS' #food) #('VIDEO RENTAL' #recreation) #('FIRE STATION' #service) #('SURF SHOP' #retail) #('PANCAKE HOUSE' #food) #('MAPPLE STORE' #retail) #('BARBER SHOP' #service) #('NIGHT CLUB' #recreation) #('MECHANIC' #service) #('FABRIC SHOP' #retail) #('CHEESE SHOP' #food) #('STABLES' #service) #('FASHION STUDIO' #creative) #('ART STUDIO' #creative) #('MINI GOLF' #recreation) #('HOME SUPPLY' #retail) )
		do: [ :each| self addJobNamed: each first type: each second ]! !

!TinyTowerGame methodsFor: 'mission' stamp: 'HwaJong 3/12/2014 22:54'!
addAllKnownMissions
 #(#(10 'ONE MAD TEA PARTY' #('TEA HOUSE' 'BAKERY')) #(20 'COMIC CONVENTION' #('COMIC STORE' 'PHARMACY')) #(30 'AWARD NIGHT' #('DENTISTS OFFICE' 'BARBER SHOP')) #(40 'THE DUDE ABIDES' #('BOWLING ALLEY' 'PUB')) #(50 'ONE BIG SCORE' #('BANK' 'CASINO')) #(60 'BITHOVEN''S SYMPHONY' #('WOOD SHOP' 'MUSIC STORE')) #(70 'PROM NIGHT' #('FLORAL STUDIO' 'MENS FASHION')) #(80 'A BIT FISHY' #('SUSHI BAR' 'MEXICAN FOOD')) #(90 'THANKSGIVING FEAST' #('FANCY CUISINE' 'TRAVEL AGENCY')) #(100 'ON THE BEAT' #('DINER' 'DONUT SHOP')) #(110 'THE HEIST' #('SECURITY OFFICE')) #(120 'SOY LOCO' #('ASIAN CUISINE' 'VEGAN FOOD')) #(130 'SANTA''S SWAP' #('BAKERY' 'TOY STORE')) #(140 'NEW YEARS 2012' #('NIGHT CLUB' 'HEALTH CLUB')) #(150 'SAVE THE PLANET' #('BIKE SHOP' 'VEGAN FOOD')) #(160 'NASTY BUG' #('PHARMACY' 'DINER')) #(170 'LAST NIGHT' #('PUB' 'TATTOO PARLOR')) #(180 'HOT TRENDS' #('COFFEE HOUSE' 'RECORD SHOP')) #(190 'THE BIG GAME' #('TECH STORE' 'PUB')) #(200 'VALENTINE''S 2012' #('DAY SPA' 'FLORAL STUDIO')) #(210 'PRESIDENTS DAY 2012' #('AUTO DEALER' 'FURNITURE STORE')) #(220 'BEWARE OF DOG' #('ARCHITECT OFFICE' 'GAME STUDIO')) #(230 'SUPERSTAR' #('GRAPHIC DESIGN' 'RECORD SHOP')) #(240 'BITS IN SPACE' #('TOY STORE' 'PLANETARIUM')) #(250 'ST. PATTY''S 2012' #('TEA HOUSE' 'GLASS STUDIO')) #(260 'A BABY IS BORN!!' #('PHOTO STUDIO' 'TOY STORE')) #(270 'WEDDING SEASON' #('WEDDING CHAPEL' 'FLORAL STUDIO')) #(280 'APRIL FOOL''S 2012' #('COMEDY CLUB' 'BILLIARD HALL')) #(290 'SPRING TIME' #('FLORAL STUDIO' 'TATTOO PARLOR')) #(300 'TINY TAXES' #('TUTORING CENTER' 'BANK')) #(310 'EARTH DAY 2012' #('PLANT NURSERY' 'RECYCLING')) #(320 'CINCO DE MAYO 2012' #('MEXICAN FOOD' 'MUSIC STORE')) #(330 'MOTHER''S DAY 2012' #('DAY SPA' 'WOMENS FASHION')) #(340 'SUMMER VACATION' #('TRAVEL AGENCY' 'SCOOPS')) #(350 'SUMMER SCHOOL' #('BOOK STORE' 'TUTORING CENTER')) #(360 'FIRST APARTMENT' #('FURNITURE STORE' 'POTTERY STUDIO')) #(370 'TEAM TINY' #('DOCTORS OFFICE' 'HEALTH CLUB')) #(380 'TOWER WATCH' #('SECURITY OFFICE' 'PRIVATE EYE')) #(390 'FATHER''S DAY 2012' #('BIKE SHOP' 'ANIMATION STUDIO')) #(400 'POCKET PLANES' #('TRAVEL AGENCY' 'PUB')) #(410 'A DAY AT THE BEACH' #('SHOE STORE' 'VOLLEYBALL CLUB' 'FROZEN YOGURT')) #(420 'BEAT THE HEAT' #('COFFEE HOUSE' 'PUB' 'SODA BREWERY')) #(430 'FROG FUNDRAISER' #('MUSEUM' 'FANCY CUISINE')) #(440 'LONDON GAMES' #('VOLLEYBALL CLUB' 'SHOE STORE' 'RACQUETBALL')) #(450 'MARS CURIOSITY' #('PLANETARIUM' 'LABORATORY')) #(460 'SELF DEFENSE' #('MARTIAL ARTS' 'SECURITY OFFICE')) #(470 'MUSIC FESTIVAL' #('MUSIC STORE' 'RECORDING STUDIO')) #(480 'BIT TREK TNG' #('ANIMATION STUDIO' 'TECH STORE')) #(490 'LABOR DAY 2012' #('AUTO DEALER' 'SECURITY OFFICE')) #(500 'FIRE DRILL' #('SECURITY OFFICE' 'ARCHITECT OFFICE')) #(510 'BACK TO WIZ SCHOOL' #('FORTUNE TELLER' 'LABORATORY' 'BOOK STORE')) #(520 'MYPHONE 5 LAUNCH' #('MAPPLE STORE' 'TV STUDIO')) #(530 'COWABUNGA' #('LABORATORY' 'MARTIAL ARTS' 'PIZZA PLACE')) #(540 'CANADIAN THANKS 2012' #('VEGAN FOOD' 'FANCY CUISINE')) #(550 'BASEBALL PLAYOFFS' #('PUB' 'CINEPLEX')) #(560 'MIMECON 2012' #('DAY SPA' 'THEATER')) #(570 'HALLOWEEN 2012' #('CHOCOLATIER' 'LABORATORY' 'HAUNTED HOUSE')) #(580 'ELECTION 2012' #('AD AGENCY' 'TV STUDIO')) #(590 'NORTH POLE RECON' #('PRIVATE EYE' 'FORTUNE TELLER')) #(600 'BOARD MEETING' #('SUB SHOP' 'BAKERY' 'COFFEE HOUSE')) #(610 'VALENTINES 2013' #('ARCHERY RANGE' 'CHOCOLATIER')) #(620 'NATIONAL PIG DAY' #('HAT SHOP' 'PHOTO STUDIO')) #(630 'ST. PATTY''S DAY 2013' #('BAKERY' 'HAT SHOP')) #(640 'TOWER TAXES' #('TUTORING CENTER' 'BANK')) #(650 'ARBOR DAY 2013' #('PLANT NURSERY' 'SUB SHOP')) #(660 'CINCO DE MAYO 2013' #('MEXICAN FOOD' 'MUSIC STORE')) #(670 'MOTHER''S DAY 2013' #('WOMENS FASHION' 'JEWELRY STORE' 'DAY SPA')) #(680 'ARMED FORCES DAY 2013' #('TOY STORE' 'BARBER SHOP' 'SECURITY OFFICE')) #(690 'MEMORIAL DAY 2013' #('MUSIC STORE' 'FLORAL STUDIO')) #(700 'FEEL THE EARTH' #('BIKE SHOP' 'RECYCLING')) #(710 'FLAG DAY 2013' #('FABRIC SHOP')) #(720 'FATHER''S DAY 2013' #('TECH STORE' 'ANIMATION STUDIO')) #(730 'SOLSTICE' #('SHOE STORE' 'PARK')) #(740 'INDEPENDENCE DAY ''13' #('HOT DOG JOINT' 'HAT SHOP')) #(750 'ABORIGINAL DAY' #('ARCHERY RANGE' 'COSTUME SHOP')) #(760 'PIONEER DAY' #('MECHANIC' 'TECH STORE')) #(770 'BOOK LOVERS DAY' #('WOOD SHOP' 'BOOK STORE')) #(780 'SUMMER VACATION ''13' #('SURF SHOP' 'SMOOTHIE SHOP')) #(790 'RELAXATION DAY' #('DAY SPA' 'CANDLE SHOP')) #(800 'AVIATION DAY' #('TRAVEL AGENCY' 'PUB')) #(810 'SENIOR CITIZENS DAY' #('PARK' 'WOMENS FASHION' 'MENS FASHION')) #(820 'LABOR DAY ''13' #('PLUMBER' 'FIRE STATION')) #(830 'PROGRAMMERS'' DAY' #('TECH STORE' 'SOFTWARE STUDIO')) #(840 'OKTOBERFEST ''13' #('PUB' 'CLOCKMAKER')) #(850 'CONFUCIUS DAY' #('MARTIAL ARTS' 'ASIAN CUISINE')) #(860 'WORLD VEGETARIAN DAY' #('VEGAN FOOD' 'PLANT NURSERY')) #(870 'FIRE PREVENTION DAY' #('FIRE STATION' 'AD AGENCY')) #(695 'JFK''S BIRTHDAY' #('TOY STORE' 'TV STUDIO')) #(755 'MOON DAY' #('TOY STORE' 'SCOOPS')))
	do: [ :each| self addMissionWithProxy: (TTMissionProxy ordinalNumber: each first name: each second requiredJobNames: each third ) ]! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 3/30/2014 01:22'!
addBitizen: aBitizen

	self bitizens add: aBitizen.
	aBitizen game: self.
	self beDirty.
	^aBitizen! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 3/30/2014 01:23'!
addBitizen: aBitizen atHome: aFloor

	self bitizens add: aBitizen.
	aFloor addResidentBitizen: aBitizen.
	aBitizen game: self.
	self beDirty.
	^aBitizen! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 2/16/2014 12:07'!
addBitizenName: string1 dreamJobName: string2 food: integer2 service: integer3 recreation: integer4 retail: integer5 creative: integer6

	| b d |
	b := Bitizen new bitName: string1.
	d := self jobNamed: string2.
	b foodAbility: integer2.
	b serviceAbility: integer3.
	b recreationAbility: integer4.
	b retailAbility: integer5.
	b creativeAbility: integer6.
	b dreamJob: d.
	^self addBitizen: b.! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 2/16/2014 09:58'!
addBitizenName: string1 dreamJobName: string2 homeFoorNumber: integer1 food: integer2 service: integer3 recreation: integer4 retail: integer5 creative: integer6

	| b |
	b := Bitizen new bitName: string1.
	b foodAbility: integer2.
	b serviceAbility: integer3.
	b recreationAbility: integer4.
	b retailAbility: integer5.
	b creativeAbility: integer6.
	b dreamJob: (self jobNamed: string2).
	b homeFoorNumber: integer1.
	^self addBitizen: b.! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 2/16/2014 12:03'!
addBitizenName: string1 dreamJobName: string2 homeFoorNumber: integer1 food: integer2 service: integer3 recreation: integer4 retail: integer5 creative: integer6 employedAt: string3


	| b  h w |
	b := Bitizen new bitName: string1.
	h := self floorAt: integer1.
	w := self floorJobNamed: string3.
	b foodAbility: integer2.
	b serviceAbility: integer3.
	b recreationAbility: integer4.
	b retailAbility: integer5.
	b creativeAbility: integer6.
	b dreamJob: (self jobNamed: string2).
	h moveInBitizen: b.
	w employBitizen: b.
	^self addBitizen: b.! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 2/15/2014 22:24'!
addBitizenName: string1 dreamType: symbol1 dreamJobName: string2 food: integer2 service: integer3 recreation: integer4 retail: integer5 creative: integer6

	| b |
	b := Bitizen new bitName: string1.
	b foodAbility: integer2.
	b serviceAbility: integer3.
	b recreationAbility: integer4.
	b retailAbility: integer5.
	b creativeAbility: integer6.
	b dreamJob: (self addJobNamed: string2 type: symbol1).
	^self addBitizen: b.! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 2/16/2014 09:58'!
addBitizenName: string1 dreamType: symbol1 dreamJobName: string2 homeFoorNumber: integer1 food: integer2 service: integer3 recreation: integer4 retail: integer5 creative: integer6

	| b |
	b := Bitizen new bitName: string1.
	b foodAbility: integer2.
	b serviceAbility: integer3.
	b recreationAbility: integer4.
	b retailAbility: integer5.
	b creativeAbility: integer6.
	b dreamJob: (self addJobNamed: string2 type: symbol1).
	b homeFloor: (self floorAt: integer1).
	^self addBitizen: b.! !

!TinyTowerGame methodsFor: 'floor' stamp: 'HwaJong 3/1/2014 01:00'!
addCommercialFloorJobNamed: aString

	[self addFloor: (CommercialFloor new job: (self jobNamed: aString))] on: TTNoJobError
		do: [ :exp| 
			exp addJobAndRetry]! !

!TinyTowerGame methodsFor: 'floor' stamp: 'HwaJong 3/30/2014 01:24'!
addFloor: aFloor
	self floors add: aFloor.
	aFloor number: (self floors indexOf: aFloor).
	aFloor game: self.
	self beDirty.! !

!TinyTowerGame methodsFor: 'job' stamp: 'HwaJong 3/30/2014 01:24'!
addJob: aTTJob 
	self jobs add: aTTJob.
	aTTJob game: self.
	self beDirty.! !

!TinyTowerGame methodsFor: 'job' stamp: 'HwaJong 3/18/2014 12:03'!
addJobNamed: aString 
	| cb |
	cb := ChooseFromBuilder new.
	cb title: 'type of job ', aString asUppercase.
	self jobClasses do: 
		[:each| cb choiceString: each typeName value: 
			[ |job|
			job := each new jobName: aString.
			self addJob: job.
			^job ] ].
	cb chooseFromValuesTitle.! !

!TinyTowerGame methodsFor: 'job' stamp: 'HwaJong 2/15/2014 22:54'!
addJobNamed: aString type: aString2 
	^self addJob: ((TTJob subclassOfTypeName: aString2) new jobName: aString)! !

!TinyTowerGame methodsFor: 'floor' stamp: 'HwaJong 2/15/2014 19:55'!
addLoungeFloor
	self addFloor: (LoungeFloor new)! !

!TinyTowerGame methodsFor: 'mission' stamp: 'HwaJong 3/30/2014 17:50'!
addMission: aTTMission 

	aTTMission ordinalNumber: 
		(self missions isEmpty
			ifTrue: [ 0 ]
			ifFalse: [ self missions last ordinalNumber ]) + 10.

	self missions add: aTTMission.
	aTTMission game: self.
	self beDirty.! !

!TinyTowerGame methodsFor: 'mission' stamp: 'HwaJong 3/1/2014 17:56'!
addMissionWithProxy: aTTMissionProxy 
	|aTTMission|
	aTTMission := aTTMissionProxy valueWithGame: self.
	(aTTMission requiredJobs allSatisfy: [ :each| each isKindOf: TTJob ])
		ifTrue: [ self addMission: aTTMission ]! !

!TinyTowerGame methodsFor: 'floor' stamp: 'HwaJong 2/16/2014 00:23'!
addReisdentalFloor
	self addFloor: (ResidentFloor new)! !

!TinyTowerGame methodsFor: 'announcer' stamp: 'HwaJong 2/22/2014 21:08'!
announcer
	^ announcer setDefault: #announcerDefault for: self withSetter: #announcer:! !

!TinyTowerGame methodsFor: 'announcer' stamp: 'HwaJong 2/22/2014 21:15'!
announcer: anAnnouncer 
	announcer ifNotNil: [ announcer unsubscribe: self ].
	announcer := anAnnouncer! !

!TinyTowerGame methodsFor: 'announcer' stamp: 'HwaJong 3/5/2014 15:37'!
announcerDefault
	^Announcer new
		on: ElementOfHashedCollectionChanged do: 
			[ :ann| 
				(ann element isKindOf: Bitizen) ifTrue: [self bitizens rehash].
				(ann element isKindOf: TTJob) ifTrue: [self jobs rehash] ];
			yourself! !

!TinyTowerGame methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/30/2014 00:08'!
beDirty
	self docLogic hasUnsavedChange: true! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 2/22/2014 01:29'!
bitizenFromUser

	|bitiArray|
	bitiArray := bitizens asArray.
	^bitiArray at: (UIManager default chooseFrom: (bitiArray collect: #bitName))
	! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 2/16/2014 01:34'!
bitizenNamed: aString 
	|up|
	up := aString asUppercase.
	^self bitizens detect: [ :each| each bitName = up ]! !

!TinyTowerGame methodsFor: 'accessing' stamp: 'HwaJong 2/15/2014 19:40'!
bitizens
	^bitizens setDefault: #bitizensDefault for: self withSetter: #bitizens:! !

!TinyTowerGame methodsFor: 'accessing' stamp: 'HwaJong 2/15/2014 19:40'!
bitizens: aCollection
	bitizens := aCollection! !

!TinyTowerGame methodsFor: 'accessing' stamp: 'HwaJong 2/15/2014 19:40'!
bitizensDefault
	^Set new! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 3/10/2014 12:59'!
bitizensNotEmployedToNotToUseBestAbility
	^self bitizens select: [ :each| each employedToNotToUseBestAbility ].! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 3/19/2014 00:23'!
bitizensWhoCanGetTheirDreamJob
	^(self bitizens select: [ :each| each gotDreamJob not ]) select: [ :each| self jobsInBuilding includes: each dreamJob ]. ! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 3/12/2014 11:43'!
bitizensWhoDoesNotGetDreamJobAndNotUsingItsBestAbility
	^self bitizens select: [:each| each gotDreamJob not and: [ each employedToNotToUseBestAbility ] ]! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 3/12/2014 11:45'!
bitizensWhoDoesNotGetDreamJobAndNotUsingItsBestAbilityOrNotEmployed
	^self bitizens select: 
		[:each| 
		(each gotDreamJob not and: [ each employedToNotToUseBestAbility ])
		or: 
		[ each hasJob not ] ]! !

!TinyTowerGame methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/29/2014 10:05'!
commercialFloorOfJob: aTTJob 

	^self commercialFloors detect: [ :each| each job = aTTJob ]! !

!TinyTowerGame methodsFor: 'floor' stamp: 'HwaJong 2/25/2014 10:28'!
commercialFloors
	^self floors select: [ :each| each isCommercialFloor ]! !

!TinyTowerGame methodsFor: 'floor' stamp: 'HwaJong 2/28/2014 20:51'!
commercialFloorsNeedingBitizen
	^self commercialFloors select: [ :each| each isBitizenful not ]! !

!TinyTowerGame methodsFor: 'accessing' stamp: 'HwaJong 3/30/2014 00:08'!
docLogic
	^docLogic setDefault: #docLogicDefault for: self withSetter: #docLogic:! !

!TinyTowerGame methodsFor: 'accessing' stamp: 'HwaJong 3/30/2014 00:08'!
docLogic: anObject

	docLogic := anObject! !

!TinyTowerGame methodsFor: 'defaults' stamp: 'HwaJong 3/30/2014 00:09'!
docLogicDefault
	^TinyTowerGameDocLogic new
		game: self! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 3/19/2014 23:10'!
employedBitizens
	^self bitizens select: [ :each| each isEmployeed ]! !

!TinyTowerGame methodsFor: 'floor' stamp: 'HwaJong 12/10/2012 17:47'!
floorAt: aSmallInteger 
	^floors detect: [:each| each number = aSmallInteger]! !

!TinyTowerGame methodsFor: 'floor' stamp: 'HwaJong 3/11/2014 22:57'!
floorAtNumber: anInteger
	| f |
	f := self floors at: anInteger.
	[f number = anInteger] assert.
	^f! !

!TinyTowerGame methodsFor: 'floor' stamp: 'HwaJong 2/16/2014 10:04'!
floorJobNamed: aByteString 
	| up |
	up := aByteString asUppercase.
	^floors detect: [:each| each hasJobNamed: up] ! !

!TinyTowerGame methodsFor: 'accessing' stamp: 'HwaJong 2/15/2014 19:54'!
floors
	^floors setDefault: #floorsDefault for: self withSetter:  #floors:  afterSetOperation: #addLoungeFloor! !

!TinyTowerGame methodsFor: 'accessing' stamp: 'HwaJong 2/15/2014 19:41'!
floors: aCollection
	floors := aCollection! !

!TinyTowerGame methodsFor: 'accessing' stamp: 'HwaJong 2/15/2014 19:54'!
floorsDefault
	^OrderedCollection new! !

!TinyTowerGame methodsFor: 'floor' stamp: 'HwaJong 3/20/2014 13:35'!
floorsNeedingBitizen
	^self floors select: [ :each| each isBitizenful not ]! !

!TinyTowerGame methodsFor: 'comparing' stamp: 'HwaJong 4/2/2014 23:42'!
gettersForEquality
	^#(floors jobs missionsAsArray bitizens)! !

!TinyTowerGame methodsFor: 'job' stamp: 'HwaJong 3/1/2014 17:52'!
hasJobNamed: aString 
	^(self nilOrJobNamed: aString) notNil! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 2/23/2014 00:25'!
homelessBitizens
	^self bitizens select: [ :each| each hasHome not ]! !

!TinyTowerGame methodsFor: 'testing' stamp: 'HwaJong 3/30/2014 00:29'!
isDummyGame
	^false! !

!TinyTowerGame methodsFor: 'testing' stamp: 'HwaJong 3/31/2014 21:13'!
isHealthy
	^{[self jobs allSatisfy: #isHealthy].
	[self floors allSatisfy: #isHealthy].
	[self bitizens allSatisfy: #isHealthy].
	[self missions allSatisfy: #isHealthy].
	[(SeqColSnake new sequenceableCollection: self missions length: 2 overlapping: 1) 
		allSatisfy: [:two| two first ordinalNumber < two second ordinalNumber ]] .
	[(self floors collect: [ :each| each number ]) asArray = (1 to: self floors size) asArray]} allSatisfied! !

!TinyTowerGame methodsFor: 'job' stamp: 'HwaJong 3/18/2014 12:05'!
jobClasses
	^self class jobClasses! !

!TinyTowerGame methodsFor: 'job' stamp: 'HwaJong 2/16/2014 01:08'!
jobNamed: aString 
	|upperString|
	upperString := aString asUppercase.
	^self jobs detect: [ :each| each jobName = upperString ] ifNone: [ TTNoJobError new game: self; jobName: aString; signal ]! !

!TinyTowerGame methodsFor: 'accessing' stamp: 'HwaJong 3/12/2014 17:19'!
jobs

	^jobs setDefault: #jobsDefault for: self withSetter: #jobs: afterSetOperation: #addAllKnownJobs! !

!TinyTowerGame methodsFor: 'accessing' stamp: 'HwaJong 2/15/2014 19:46'!
jobs: anObject
		
	jobs := anObject! !

!TinyTowerGame methodsFor: 'defaults' stamp: 'HwaJong 2/15/2014 19:47'!
jobsDefault

	^Set new! !

!TinyTowerGame methodsFor: 'job' stamp: 'HwaJong 2/26/2014 17:37'!
jobsInBuilding
	^self commercialFloors collect: #job! !

!TinyTowerGame methodsFor: 'testing' stamp: 'HwaJong 3/11/2014 18:58'!
leastElevatorPpmRequired
	^self leastElevatorPpmRequiredIfFloorSize: self floors size! !

!TinyTowerGame methodsFor: 'testing' stamp: 'HwaJong 3/11/2014 19:01'!
leastElevatorPpmRequiredIfFloorSize: anInteger
	|pps maxFloorSize maxPps floatPps|
	maxFloorSize := 193.
	pps := { 42. 16. 12. 8. 4 }.
	maxPps := pps first.
	floatPps := anInteger / maxFloorSize * maxPps.
	^(pps select: [ :each| each >= floatPps ]) asSortedCollection first.! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 3/20/2014 19:35'!
makeAllBitizensHomeless
	self bitizens do: #beHomeless! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 2/23/2014 22:20'!
makeAllBitizensJobless
	self bitizens do: [ :each| each beJobless ]! !

!TinyTowerGame methodsFor: 'mission' stamp: 'HwaJong 3/12/2014 22:54'!
missions
	^missions setDefault: #missionsDefault for: self withSetter: #missions: afterSetOperation: #addAllKnownMissions! !

!TinyTowerGame methodsFor: 'mission' stamp: 'HwaJong 3/1/2014 00:37'!
missions: aCollection 
	missions := aCollection! !

!TinyTowerGame methodsFor: 'as yet unclassified ' stamp: 'HwaJong 4/2/2014 23:42'!
missionsAsArray
	^self missions asArray! !

!TinyTowerGame methodsFor: 'mission' stamp: 'HwaJong 3/1/2014 00:37'!
missionsDefault
	^SortedCollection sortBlock: (UnarySortDescriptor ascendingBy: #ordinalNumber)! !

!TinyTowerGame methodsFor: 'mission' stamp: 'HwaJong 3/2/2014 13:54'!
missionsNotDoneYet
	^self missions select: [ :each| each isDone not ]! !

!TinyTowerGame methodsFor: 'mission' stamp: 'HwaJong 3/2/2014 13:57'!
missionsNotDoneYetButCanBeDone
	^self missionsNotDoneYet select: [:each| each canBeDone]. ! !

!TinyTowerGame methodsFor: 'job' stamp: 'HwaJong 3/1/2014 17:52'!
nilOrJobNamed: aString 
	|upperString|
	upperString := aString asUppercase.
	^self jobs detect: [ :each| each jobName = upperString ] ifNone: [ nil ]! !

!TinyTowerGame methodsFor: 'testing' stamp: 'HwaJong 3/11/2014 15:37'!
overcrowdedDreamJobAssociations
	| dreamJobGroup |
	dreamJobGroup := Dictionary new.
	self bitizens do: [:each| (dreamJobGroup at: each dreamJob ifAbsentPut: [OrderedCollection new]) add: each ].
	^dreamJobGroup associations select: [:each| each value size > 3 ]! !

!TinyTowerGame methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/31/2014 19:40'!
recommendedJobTypeNameForNewCommercialFloor
|bc|
bc := BitizenCollection new bitizens: (self bitizens select: [ :each| each gotDreamJob not ]) asBag.
^bc sortedCountsOfDreamJobTypeName.! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 3/30/2014 01:23'!
removeBitizen: aBitizen 
	self bitizens remove: aBitizen.
	aBitizen homeFloor
		ifNotNil: [:that| that removeBitizen: aBitizen].
	aBitizen jobFloor 
		ifNotNil: [:that| that removeBitizen: aBitizen].
	self beDirty.! !

!TinyTowerGame methodsFor: 'floor' stamp: 'HwaJong 3/30/2014 01:23'!
removeFloor: aResidentFloor 
	self floors remove: aResidentFloor.
	aResidentFloor game: nil.
	self beDirty.! !

!TinyTowerGame methodsFor: 'job' stamp: 'HwaJong 3/30/2014 01:23'!
removeJob: aTTJob 
	
	self floors do: [ :each| (each checkUsingJob: aTTJob) ].
	self bitizens do: [ :each| (each checkUsingJob: aTTJob) ].
	self missions do: [ :each| (each checkUsingJob: aTTJob) ].
	
	self jobs remove: aTTJob.
	aTTJob game: nil.
	self beDirty.! !

!TinyTowerGame methodsFor: 'mission' stamp: 'HwaJong 3/30/2014 01:23'!
removeMission: aTTMission 
	self missions remove: aTTMission.
	aTTMission game: nil.
	self beDirty.! !

!TinyTowerGame methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/20/2014 13:06'!
replaceWorseEmployedBitizenWithBetterUnemployedBitizenToWinActions
	|do tape|
	do := MultiDimensionalDo new.
	do domains: {self employedBitizens asArray. self unemployedBitizens asArray}.
	tape := OrderedCollection new.
	do block: 
		[:employedBitizen :unemployedBitizen |
		(UnarySortDescriptor ascendingBy: 
			[:bz| (bz dreamJob = employedBitizen job) ifTrue: [1] ifFalse: [0]] ascendingBy: 
			[:bz| employedBitizen job meaningfulAbilityOfBitizen: bz ]) 
				object1: employedBitizen object2: unemployedBitizen 
				ifSame: [] ifInOrder: [tape add: (TTReplaceEmployedBitizenAction new replacedBitizen: employedBitizen; replacingBitizen: unemployedBitizen)] ifNotInOrder: []].
	do run.
	^tape
! !

!TinyTowerGame methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/20/2014 13:58'!
residentalFloors
	^self floors select: [ :each| each isKindOf: ResidentFloor ]! !

!TinyTowerGame methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/20/2014 13:59'!
residentalFloorsNeedingBitizen
	^self residentalFloors select: [ :each| each isBitizenful not ]! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 3/12/2014 11:54'!
shuffleBitizensWhoDoesNotGetDreamJobAndNotUsingItsBestAbility
|putLog|
putLog := self shufflingBitizensWhoDoesNotGetDreamJobAndNotUsingItsBestAbility.

^putLog notEmpty
	ifTrue: 
	[self bitizensWhoDoesNotGetDreamJobAndNotUsingItsBestAbility do: #beJobless.
	putLog do: [ :array| [:bitName :floorNum| (self floorAtNumber: floorNum) addBitizen: (self bitizenNamed: bitName) ] valueWithArguments: array ].
	true]
	ifFalse:
	[ false ]! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 3/12/2014 11:51'!
shufflingBitizensWhoDoesNotGetDreamJobAndNotUsingItsBestAbility
|cop notOptimizedBitizens putLog|
cop := self veryDeepCopy.

notOptimizedBitizens := cop bitizensWhoDoesNotGetDreamJobAndNotUsingItsBestAbilityOrNotEmployed.
notOptimizedBitizens do: #beJobless.


notOptimizedBitizens := notOptimizedBitizens asSet.

putLog := OrderedCollection new.

cop commercialFloorsNeedingBitizen size timesRepeat:
	[|aBit aFlo|
	aBit := notOptimizedBitizens atRandom.
	aFlo := cop commercialFloorsNeedingBitizen atRandom.
	putLog add: { aBit bitName. aFlo number }.
	aFlo addBitizen: aBit.
	notOptimizedBitizens remove: aBit].

^self utilizedAbility < cop utilizedAbility
	ifTrue: 
		[putLog]
	ifFalse: 
		[OrderedCollection new].! !

!TinyTowerGame methodsFor: 'job' stamp: 'HwaJong 3/2/2014 01:17'!
thoseReferencingJob: aJob 
	|those work|
	those := Set new.
	work := [  :each| (each referencesJob: aJob) ifTrue: [ those add: each ]  ].
	self floors do: work.
	self bitizens do: work.
	self missions do: work.
	^those! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 3/19/2014 21:46'!
unemployedBitizens
	^self bitizens select: [ :each| each isEmployeed not ]! !

!TinyTowerGame methodsFor: 'job' stamp: 'HwaJong 3/1/2014 17:15'!
unflooredJobs
	^self jobs difference: (self jobsInBuilding)! !

!TinyTowerGame methodsFor: 'testing' stamp: 'HwaJong 3/11/2014 19:13'!
utilizedAbility
	^self bitizens asArray inject: 0 into: [:sum :each| 
		sum := sum +
			(each hasJob
				ifTrue: [each job meaningfulAbilityOfBitizen: each]
				ifFalse: [0]) ]! !

Object subclass: #TinyTowerGameController
	instanceVariableNames: 'model mainTabGroupMorph bitizenListController missionListController floorListController jobListController issueListController'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!TinyTowerGameController commentStamp: '' prior: 0!
A TinyTowerGame is xxxxxxxxx.

Instance Variables
	bitizens:		<Object>
	floors:		<Object>

bitizens
	- xxxxx

floors
	- xxxxx
!

!TinyTowerGameController class methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 19:35'!
workspace1
| tt |
tt := TinyTowerGame new.
tt openBitizenListMorph.
tt openCommercialFloorListMorph.
tt bitizenFromUser.! !

!TinyTowerGameController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/22/2014 12:03'!
addModelItemsToWindowMenu: aMenu

	super addModelItemsToWindowMenu: aMenu.
	aMenu addLine.
	aMenu add: 'inspect model' target: self action: #inspect.
	aMenu add: 'reopen' target: self action: #reopen.! !

!TinyTowerGameController methodsFor: 'accessing' stamp: 'HwaJong 3/8/2014 22:10'!
bitizenListController

	^bitizenListController setDefault: #bitizenListControllerDefault for: self withSetter: #bitizenListController:! !

!TinyTowerGameController methodsFor: 'accessing' stamp: 'HwaJong 3/8/2014 22:09'!
bitizenListController: anObject
		
	bitizenListController := anObject! !

!TinyTowerGameController methodsFor: 'defaults' stamp: 'HwaJong 3/8/2014 22:10'!
bitizenListControllerDefault

	^BitizenListController new ownerController: self! !

!TinyTowerGameController methodsFor: 'accessing' stamp: 'HwaJong 3/12/2014 21:58'!
floorListController

	^floorListController setDefault: #floorListControllerDefault for: self withSetter: #floorListController:! !

!TinyTowerGameController methodsFor: 'accessing' stamp: 'HwaJong 3/12/2014 21:58'!
floorListController: anObject
		
	floorListController := anObject! !

!TinyTowerGameController methodsFor: 'defaults' stamp: 'HwaJong 3/12/2014 21:58'!
floorListControllerDefault

	^FloorListController new ownerController: self! !

!TinyTowerGameController methodsFor: 'accessing' stamp: 'HwaJong 3/13/2014 16:30'!
issueListController

	^issueListController setDefault: #issueListControllerDefault for: self withSetter: #issueListController:! !

!TinyTowerGameController methodsFor: 'accessing' stamp: 'HwaJong 3/13/2014 16:29'!
issueListController: anObject
		
	issueListController := anObject! !

!TinyTowerGameController methodsFor: 'defaults' stamp: 'HwaJong 3/13/2014 16:30'!
issueListControllerDefault

	^IssueListController new ownerController: self! !

!TinyTowerGameController methodsFor: 'accessing' stamp: 'HwaJong 3/12/2014 22:59'!
jobListController

	^jobListController setDefault: #jobListControllerDefault for: self withSetter: #jobListController:! !

!TinyTowerGameController methodsFor: 'accessing' stamp: 'HwaJong 3/12/2014 22:58'!
jobListController: anObject
		
	jobListController := anObject! !

!TinyTowerGameController methodsFor: 'defaults' stamp: 'HwaJong 3/12/2014 22:59'!
jobListControllerDefault

	^JobListController new ownerController: self! !

!TinyTowerGameController methodsFor: 'accessing' stamp: 'HwaJong 3/12/2014 17:59'!
missionListController

	^missionListController setDefault: #missionListControllerDefault for: self withSetter: #missionListController:! !

!TinyTowerGameController methodsFor: 'accessing' stamp: 'HwaJong 3/12/2014 17:59'!
missionListController: anObject
		
	missionListController := anObject! !

!TinyTowerGameController methodsFor: 'defaults' stamp: 'HwaJong 3/12/2014 18:00'!
missionListControllerDefault

	^MissionListController new
		ownerController: self! !

!TinyTowerGameController methodsFor: 'accessing' stamp: 'HwaJong 3/8/2014 22:21'!
model
	^ model! !

!TinyTowerGameController methodsFor: 'accessing' stamp: 'HwaJong 2/15/2014 20:48'!
model: aTinyTowerGame
	model := aTinyTowerGame! !

!TinyTowerGameController methodsFor: 'main morphic' stamp: 'HwaJong 3/22/2014 12:00'!
open
	| q window |
	q := QuickPrototyping for: self.
	
	mainTabGroupMorph := UITheme builder newTabGroup: 
		{
			'job' asMorph -> 
				(self jobListController morphOfMeAndMyDetail: q).
			'floor' asMorph -> 
				(self floorListController morphOfMeAndMyDetail: q).
			'bitizen' asMorph -> 
				(self bitizenListController morphOfMeAndMyDetail: q).
			'mission' asMorph -> 
				(self missionListController morphOfMeAndMyDetail: q).
			'issue' asMorph -> 
				(self issueListController morphOfMeAndMyDetail: q)
		}.
	window := mainTabGroupMorph openInWindow.
	window setLabel: 'Tiny Tower Rocks!!'.
	window extent:  (559@454).
	window model: self.
! !

!TinyTowerGameController methodsFor: 'main morphic' stamp: 'HwaJong 3/18/2014 12:15'!
refresh
	self jobListController refresh.
	self bitizenListController refresh.
	self missionListController refresh.
	self floorListController refresh.
	self jobListController refresh.
	self issueListController refresh.! !

!TinyTowerGameController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/22/2014 12:12'!
reopen
	self changed: #close.
	self open.! !

!TinyTowerGameController methodsFor: 'accessing' stamp: 'HwaJong 3/18/2014 12:12'!
rootController
	^self! !

!TinyTowerGameController methodsFor: 'main morphic' stamp: 'HwaJong 3/18/2014 22:40'!
selectBitizen: aBitizen 
	self bitizenListController refreshListAndSelect: aBitizen! !

!TinyTowerGameController methodsFor: 'main morphic' stamp: 'HwaJong 3/10/2014 00:20'!
selectMainTabNamed: aString 
	
	mainTabGroupMorph selectTabNamed: aString ! !

!TinyTowerGameController methodsFor: 'main morphic' stamp: 'HwaJong 3/19/2014 11:13'!
showBitizen: aBitizen 
	self selectMainTabNamed: 'bitizen'.
	self selectBitizen: aBitizen! !

!TinyTowerGameController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/19/2014 12:04'!
showFloor: aFloor 
	self selectMainTabNamed: 'floor'.
	self floorListController refreshListAndSelect: aFloor! !

!TinyTowerGameController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/20/2014 00:08'!
showMission: aTTMission 
	self selectMainTabNamed: 'mission'.
	self missionListController refreshListAndSelect: aTTMission! !

Object subclass: #TinyTowerGameDummy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!TinyTowerGameDummy methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/29/2014 23:53'!
beDirty
! !

!TinyTowerGameDummy methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/30/2014 00:29'!
isDummyGame
	^true! !
TinyTowerGame initialize!
